<?php

///////////////////////////////////////////////////////////////////////////////
//                                                                           //
// KorelStar MusicServer                                                     //
// =====================                                                     //
// (c) Copyright 2000-2002 by Kristof Hamann                                 //
//                                                                           //
// Entwickelt von Kristof Hamann                                             //
// Homepage vom MusicServer: http://www.korelstar.de/musicserver/            //
//                                                                           //
// Dieses Programm darf frei genutzt werden. Jegliche Vernderung ist jedoch //
// nur fr eigene Zwecke erlaubt, solange diese Credits unverndert bleiben. //
// Das Verffentlichen des vernderten Programmes ist nicht gestattet,       //
// hingegen ist das Weitergeben dieses Tools, so wie es auf der Homepage vom //
// MusicServer verffentlicht wurde, gestattet.                              //
//                                                                           //
// Da dieses Programm kostenlos ist, kann kein Support gewhrleistet werden. //
// Fr durch dieses Programm entstandene Schden wird nicht gehaftet.        //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////


// Falls register_globals auf off: lese Parameter-Variablen aus...
if(is_array($_GET)) extract($_GET, EXTR_OVERWRITE);
elseif(is_array($HTTP_GET_VARS)) extract($HTTP_GET_VARS, EXTR_OVERWRITE);
if(is_array($_POST)) extract($_POST, EXTR_OVERWRITE);
elseif(is_array($HTTP_POST_VARS)) extract($HTTP_POST_VARS, EXTR_OVERWRITE);

if(basename($PHP_SELF)=="index.php") $PHP_SELF=dirname($PHP_SELF)."/";
if($PHP_SELF=="//") $PHP_SELF="/";

require("cron/var.php");
require("cron/functions.php");

clearstatcache();

// sicherheits-check
if(isset($d) && strstr($d,".."))
{
	header("Location: http://".getenv("HTTP_HOST")."$PHP_SELF");
	exit;
}
if(isset($d) && substr($d,0,1)=="/")
{
	header("Location: http://".getenv("HTTP_HOST")."$PHP_SELF");
	exit;
}

if(isset($datei)) $datei = stripslashes($datei);
if(isset($datei) && strstr($datei,".."))
{
	header("Location: http://".getenv("HTTP_HOST")."$PHP_SELF");
	exit;
}
if(isset($datei) && substr($datei,0,1)=="/")
{
	header("Location: http://".getenv("HTTP_HOST")."$PHP_SELF");
	exit;
}


// String fr Song-Hinzufgen (kommt oft vor)
$str_form_addsong = "<table border=\"0\" cellpadding=\"0\" cellspacing=\"1\">";
if($SAMBA)
{
	$str_form_addsong .= "<tr><td><input type=\"radio\" name=\"wo\" value=\"server\" checked=\"checked\" id=\"wo_server\" /></td><td><label for=\"wo_server\">Auf dem Musicserver abspielen</label></td></tr>";
}
if(empty($HELD) || get_username()==$HELD)
{
	$str_form_addsong .= "<tr><td></td><td><table border=\"0\" cellpadding=\"0\" cellspacing=\"0\">";
	$str_form_addsong .= "<tr><td><input type=\"radio\" name=\"pos\" value=\"anfang\" id=\"pos_anfang\" /></td><td><label for=\"pos_anfang\">Anfang (n&auml;chstes Lied)</label></td></tr>";
	$str_form_addsong .= "<tr><td><input type=\"radio\" name=\"pos\" value=\"ende\" checked=\"checked\" id=\"pos_ende\" /></td><td><label for=\"pos_ende\">Ende</label></td></tr>";
	$str_form_addsong .= "</table></td></tr>";
}
if(empty($HELD))
{
	$str_form_addsong .= "<tr><td></td><td><table border=\"0\" cellpadding=\"0\" cellspacing=\"0\">";
	$str_form_addsong .= "<tr><td><input type=\"checkbox\" name=\"repeat\" value=\"1\" id=\"repeat_1\" /></td><td><label for=\"repeat_1\">Song(s) wiederholen*</label></td></tr>";
	$str_form_addsong .= "</table></td></tr>";
}
if($SAMBA)
{
	$str_form_addsong .= "<tr><td><input type=\"radio\" name=\"wo\" value=\"local\" id=\"wo_local\" /></td><td><label for=\"wo_local\">Mit dem lokalen MP3-Player abspielen**</label></td></tr>";
}
$str_form_addsong .= "</table><br />";
$str_form_addsong .= "<input type=\"submit\" value=\"Song(s) hinzuf&uuml;gen\" /><br /><br />";
if(empty($HELD)) $str_form_addsong .= "<font size=\"1\">* nach dem Abspielen wieder an das Ende der Playlist h&auml;ngen</font><br />";
if($SAMBA) $str_form_addsong .= "<font size=\"1\">** Startet M3U-Datei. Dein Computer muss daf&uuml;r korrekt konfiguriert sein</font><br />";


///////////////////////////////////////////////////////////////////////////////
//   FESTPLATTEN-STATUS                                                      //
///////////////////////////////////////////////////////////////////////////////
if($action=="img")
{
	// pixel angaben
	$e_w=120; $e_h=50; $e_mx=$e_w/2; $e_my=$e_h/2;
	$width=$e_w+1; $height=$e_h+10;
	$im = imagecreate($width,$height);
	// farben definieren
	$col = array();
	$col["bg"]    = imagecolorallocate($im,240,240,240);
	$col["white"] = imagecolorallocate($im,255,255,255);
	$col["black"] = imagecolorallocate($im,000,000,000);
	$col["grey"]  = imagecolorallocate($im,212,208,200);
	imagecolortransparent($im,$col["bg"]);
	// kreis und halbkreis
	imagearc($im, $e_mx, $e_my,   $e_w, $e_h, 0, 360, $col["black"]);
	imagearc($im, $e_mx, $e_my+9, $e_w, $e_h, 0, 180, $col["black"]);
	// verbindung von den kreisen
	imageline($im, $e_mx-$e_w/2, $e_my, $e_mx-$e_w/2, $e_my+9, $col["black"]);
	imageline($im, $e_mx+$e_w/2, $e_my, $e_mx+$e_w/2, $e_my+9, $col["black"]);
	// linie status
	imageline($im, $e_mx-$e_w/2, $e_my, $e_mx, $e_my, $col["black"]);
	$alpha = 360*$used/($used+$free)-180;
	imageline($im, $e_mx, $e_my, $e_mx+cos(deg2rad($alpha))*$e_w/2, $e_my+sin(deg2rad($alpha))*$e_h/2, $col["black"]);
	// farben auffllen
	imagefill($im, $e_mx, $e_my+$e_h/2+2, $col["grey"]);
	imagefill($im, $e_mx-$e_w/2+2, $e_my+1, $col["white"]);
	// die folgenden werte sind fuer sehr geringe %-zahlen
	// -177.70755721719 YES
	// -177.70755725274 NO
	if($alpha>-177.70755725) imagefill($im, $e_mx-$e_w/2+2, $e_my-1, $col["grey"]);
	header("Content-Type: image/png");
	imagepng($im);
	exit;
}
///////////////////////////////////////////////////////////////////////////////
//   C R E D I T S                                                           //
///////////////////////////////////////////////////////////////////////////////
elseif($action=="credits")
{
	echo $HEAD; flush();
	if(isset($credits))
	{
		mail("root","[MusicServer] Feedback","$nachricht\n\n".str_repeat("-",72)."\nName:    $name\neMail:   $email\n\nServer:  ".getenv("HTTP_HOST")." [".gethostbyname(getenv("HTTP_HOST"))."]\nRemote:  ".gethostbyaddr(getenv("REMOTE_ADDR"))." [".getenv("REMOTE_ADDR")."]\nBrowser: ".getenv("HTTP_USER_AGENT"),"From: $name <$email>");
		echo "<b>Vielen Dank</b><br />";
		back_button("action=credits",array("meta"));
	}
	else
	{
		echo "<b>version</b><br />";
		echo "<br />";
		echo "Version: $VER (Date: $DEV)<br />";
		echo "<br />";
		echo "<b>credits</b><br />";
		echo "<br />";
		echo "Entwickelt von Kristof Hamann<br />";
		echo "Homepage vom MusicServer: <a href=\"http://www.korelstar.de/musicserver/\" target=\"_blank\">http://www.korelstar.de/musicserver/</a><br />";
		echo "<br />";
		echo "Dieses Programm darf frei genutzt werden. Jegliche Ver&auml;nderung ist jedoch nur f&uuml;r eigene Zwecke erlaubt, solange diese Credits unver&auml;ndert bleiben. Das Ver&ouml;ffentlichen des ver&auml;nderten Programmes ist nicht gestattet, hingegen ist das Weitergeben dieses Tools, so wie es auf der Homepage vom MusicServer ver&ouml;ffentlicht wurde, gestattet.<br />";
		echo "<br />";
		echo "Da dieses Programm kostenlos ist, kann kein Support gew&auml;hrleistet werden. F&uuml;r eventuell durch dieses Programm entstandene Sch&auml;den wird nicht gehaftet.<br />";
		echo "<br />";
		echo "<b>feedback</b><br />";
		echo "<br />";
		echo "Falls dir etwas an diesem Tool nicht gef&auml;llt, du einen Fehler entdeckt hast oder einen Vorschlag zur Verbesserung hast, kannst du hier eine Nachricht schreiben (PHP muss daf&uuml;r korrekt f&uuml;r den Mail-Versand konfiguriert sein)<br />";
		echo "<br />";
		echo "<form method=\"post\" action=\"$PHP_SELF\" accept-charset=\"iso-8859-1\"><input type=\"hidden\" name=\"action\" value=\"credits\" /><input type=\"hidden\" name=\"credits\" value=\"feedback\" />";
		echo "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\">";
		echo "<tr><td>Name:&nbsp;</td><td><input size=\"25\" name=\"name\" style=\"width:300px;\" /></td></tr>";
		echo "<tr><td>eMail:&nbsp;</td><td><input size=\"25\" name=\"email\" style=\"width:300px;\" /></td></tr>";
		echo "<tr><td>Nachricht:&nbsp;</td><td><textarea name=\"nachricht\" cols=\"23\" rows=\"4\" style=\"width:300px;\"></textarea></td></tr>";
		echo "<tr><td>&nbsp;</td><td><input type=\"submit\" value=\"Senden\" /></td></tr>";
		echo "</table></form><br />";
		echo "<br />";
		echo "<b>software</b><br />";
		echo "<br />";
		echo "Der MusicServer greift auf folgende fremde Software zur&uuml;ck. Informationen zu den einzelnen Produkten gibt es auf der entsprechenden Homepage<br />";
		echo "<br />";
		echo "<table border=\"1\" cellpadding=\"0\" cellspacing=\"0\"><tr><td>";
		echo "<table border=\"0\" cellspacing=\"0\" cellpadding=\"5\" bgcolor=\"#FFFFFF\">";
		echo "<tr>";
		echo "<td align=\"center\"><a href=\"http://www.linux.org/\" target=\"_blank\"><img src=\"logo_linux.gif\" border=\"0\" width=\"91\" height=\"39\" alt=\"Linux: Betriebssystem-Kernel\" /></a></td>";
		echo "<td align=\"center\"><a href=\"http://www.samba.org/\" target=\"_blank\"><img src=\"logo_samba.gif\" border=\"0\" width=\"113\" height=\"54\" alt=\"Samba: SMB-Server f&uuml;r Linux\" /></a></td>";
		echo "<td align=\"center\"><a href=\"http://www.php.net/\" target=\"_blank\"><img src=\"logo_php.gif\" border=\"0\" width=\"95\" height=\"50\" alt=\"PHP: Web-Script-Sprache\" /></a></td>";
		echo "</tr><tr>";
		echo "<td align=\"center\" colspan=\"2\"><a href=\"http://www.apache.org/\" target=\"_blank\"><img src=\"logo_apache.gif\" border=\"0\" width=\"259\" height=\"32\" alt=\"Apache: Webserver\" /></a></td>";
		echo "<td align=\"center\"><a href=\"http://www.mysql.com/\" target=\"_blank\"><img src=\"logo_mysql.gif\" border=\"0\" width=\"135\" height=\"51\" alt=\"MySQL: Datenbank\" /></a></td>";
		echo "</tr><tr>";
		echo "<td align=\"center\" colspan=\"3\"><a href=\"http://www.freeamp.org/\" target=\"_blank\"><img src=\"logo_freeamp.gif\" border=\"0\" width=\"392\" height=\"63\" alt=\"FreeAmp: MP3-Player\" /></a></td>";
		echo "</tr>";
		echo "</table>";
		echo "</td></tr></table><br />";
		echo "<br />";
		echo "<b>version-changes</b><br />";
		echo "<br />";
		$fp = fopen("CHANGES","r");
		if($fp)
		{
			echo "<font size=\"1\">";
			while(!feof($fp))
			{
				echo str_replace("  ","&nbsp;&nbsp;",nl2br(htmlentities(fgets($fp,1024))));
			}
			echo "</font>";
		}
		else
		{
			echo "CHANGES-Datei konnte nicht ge&ouml;ffnet werden.<br />";
		}
	}
	die($FOOT);

}
///////////////////////////////////////////////////////////////////////////////
//   S T A T U S    N D E R N                                               //
///////////////////////////////////////////////////////////////////////////////
elseif($action=="next")
{
	echo $HEAD; flush();
	echo "<b>N&auml;chstes Lied</b><br /><br />";
	// Aktuelles Lied
	$result_history = mysql_query("SELECT * FROM history ORDER BY datum DESC LIMIT 1") or die(mysql_error());
	$row = mysql_fetch_array($result_history);
	$CUR = $row["datei"];
	$CURUSR = $row["user"];

	$USER = get_username();
	if(empty($HELD) || $USER==$HELD || $USER==$CURUSR)
	{
		mp3_status("restart");
	}
	else echo "Du hast keine Berechtigung den aktuellen Song zu stoppen";
	back_button("action=status",array("meta"));
	die($FOOT);


}
elseif($action=="start")
{
	echo $HEAD; flush();
	echo "<b>Starten des Abspielens</b><br /><br />";
	back_button("action=status",array("meta"));
	mp3_status("start");
	die($FOOT);


}
elseif($action=="stop")
{
	echo $HEAD; flush();
	echo "<b>Unterbrechen des Abspielens</b><br /><br />";
	back_button("action=status",array("meta"));
	// Aktuelles Lied
	$result_history = mysql_query("SELECT * FROM history ORDER BY datum DESC LIMIT 1");
	$row = mysql_fetch_array($result_history);
	$CUR = $row["datei"];
	$CURUSR = $row["user"];

	$USER = get_username();
	if(empty($HELD) || $USER==$HELD || $USER==$CURUSR)
	{
		mp3_status("stop");
	}
	else echo "Du hast keine Berechtigung den aktuellen Song zu stoppen";
	die($FOOT);


}
///////////////////////////////////////////////////////////////////////////////
//   S T A T U S :  V O L U M E                                              //
///////////////////////////////////////////////////////////////////////////////
elseif($action=="status")
{
	if($status=="volume")
	{
		if(ereg("^[[:digit:]]+$",$volume))
		{
			$step = 514;
			if($volume>25700) $volume=25700;
			if($volume<0) $volume=0;
			$OLDVOL=trim(exec($VOLPROG));
			// berechne anzahl der schritte
			$steps = floor(abs($OLDVOL-$volume)/$step);
			for($i=0;$i<$steps;$i++)
			{
				// berechne und setze teil-volume
				$vl = $OLDVOL + ($i+1)*$step*(($volume>$OLDVOL)?1:-1);
				exec($VOLPROG." ".$vl);
				usleep(500);
			}
			exec($VOLPROG." ".$volume);
			header("Location: http://".getenv("HTTP_HOST")."$PHP_SELF?action=status");
			exit;
		}
	}
	echo $HEAD; flush();
	echo "<b>Status</b> <a href=\"".$PHP_SELF."?action=status\">Aktualisieren</a><br /><br />";
	// mp3-status
	$result = mysql_query("SELECT value FROM config WHERE name='status'");
	if($result)
	{
		$STATUS = mysql_result($result,0);
		if($STATUS=="stop")
		{
			echo "Der MusicServer ist <b>gestoppt</b>. F&uuml;ge ein Lied zur Playliste und w&auml;hle in der Navigation 'start'.<br />";
		}
		elseif($STATUS=="start")
		{
		}
		else
		{
			echo "In der Konfiguration wurde ein Fehler gefunden. Der MusicServer ist anscheinend nicht korrekt installiert (unbekannter Status).<br />";
		}
	}
	else
	{
		$STATUS = "";
		echo "In der Konfiguration wurde ein Fehler gefunden. Der MusicServer ist anscheinend nicht korrekt installiert.<br />";
	}
	flush();
	$PID = trim(`ps -C $EXEC -o pid h`);
	if($PID)
	{
		if($STATUS=="start")
		{
			echo "Der MusicServer ist <b>gestartet</b> (ein Lied wird wiedergegeben)<br />";
		}
		else
		{
			echo "Es liegt ein interner Fehler vor: Der MusicServer ist <b>gestoppt</b> aber es wird trotzdem ein Lied <b>wiedergegeben</b>.<br />";
		}
		echo "<br /><br />";
		$BALKEN_BREITE = 350;
		flush();
		$result_history = mysql_query("SELECT * FROM history ORDER BY datum DESC LIMIT 1");
		$row = mysql_fetch_array($result_history);
		$CUR = $row["datei"];
		$CURUSR = $row["user"];
		$LASTBEGIN = $row["datum"];
		$mp3info = mp3_getinfo($CUR,1,1);
		echo "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\"><tr><td style=\"vertical-align:top;\">";

		echo "<table border=\"0\" cellpadding=\"2\" cellspacing=\"2\">";
		echo "<tr bgcolor=\"#D4DDEE\"><td colspan=\"2\"><b>&nbsp;Aktuelle MP3&nbsp;</b> <a href=\"$PHP_SELF?action=add&amp;datei=".urlencode($CUR)."\">Datei</a>&nbsp;</td></tr>";
		echo "<tr bgcolor=\"#DDDDDD\"><td><b>&nbsp;Gestartet von&nbsp;</b></td><td>&nbsp;<a href=\"".$PHP_SELF."?action=charts&amp;von=".urlencode($CURUSR)."\" title=\"Zeige Charts von ".htmlentities($CURUSR)."\">".htmlentities($CURUSR)."</a>&nbsp;</td></tr>";
		echo "<tr bgcolor=\"#DDDDDD\"><td><b>&nbsp;L&auml;uft&nbsp;seit&nbsp;</b></td><td>&nbsp;<span id=\"song_info_seit\">".sec2min(time()-$LASTBEGIN)."</span>&nbsp;Min&nbsp;</td></tr>";
		if($mp3info["length"]) echo "<tr bgcolor=\"#DDDDDD\"><td><b>&nbsp;Spielt&nbsp;noch&nbsp;</b></td><td>&nbsp;<span id=\"song_info_noch\">".sec2min($mp3info["length"]-time()+$LASTBEGIN)."</span>&nbsp;Min&nbsp;</td></tr>";
		if($mp3info["length"]) echo "<tr bgcolor=\"#DDDDDD\"><td><b>&nbsp;Gesamtl&auml;nge&nbsp;</b></td><td>&nbsp;".sec2min($mp3info["length"])."&nbsp;Min&nbsp;</td></tr>";
		if($mp3info["size"]) echo "<tr bgcolor=\"#DDDDDD\"><td><b>&nbsp;Gr&ouml;&szlig;e&nbsp;</b></td><td>&nbsp;".number_format($mp3info["size"]/1024/1024,2)."&nbsp;MB&nbsp;</td></tr>";
		if($mp3info["frequency"]) echo "<tr bgcolor=\"#DDDDDD\"><td><b>&nbsp;Sample-Frequ.&nbsp;</b></td><td>&nbsp;".$mp3info["frequency"]."&nbsp;Hz&nbsp;</td></tr>";
		if($mp3info["bitrate"]) echo "<tr bgcolor=\"#DDDDDD\"><td><b>&nbsp;Bit-Rate&nbsp;</b></td><td>&nbsp;".$mp3info["bitrate"]."&nbsp;KBit/s&nbsp;</td></tr>";
		if($mp3info["mode"]) echo "<tr bgcolor=\"#DDDDDD\"><td><b>&nbsp;Mode&nbsp;</b></td><td>&nbsp;".$mp3info["mode"]."&nbsp;</td></tr>";
		if($mp3info["mpeg"] && $mp3info["layer"]) echo "<tr bgcolor=\"#DDDDDD\"><td><b>&nbsp;Typ&nbsp;</b></td><td>&nbsp;MPEG-".$mp3info["mpeg"]."&nbsp;Layer&nbsp;".$mp3info["layer"]."&nbsp;</td></tr>";
		if($mp3info["artist"]) echo "<tr bgcolor=\"#DDDDDD\"><td><b>&nbsp;Artist&nbsp;</b></td><td>&nbsp;<a href=\"$PHP_SELF?action=search&amp;search=do&amp;artist=".urlencode($mp3info["artist"])."\">".htmlentities($mp3info["artist"])."</a>&nbsp;</td></tr>";
		if($mp3info["song"]) echo "<tr bgcolor=\"#DDDDDD\"><td><b>&nbsp;Song&nbsp;</b></td><td>&nbsp;<a href=\"$PHP_SELF?action=search&amp;search=do&amp;song=".urlencode($mp3info["song"])."\">".htmlentities($mp3info["song"])."</a>&nbsp;</td></tr>";
		if($mp3info["album"]) echo "<tr bgcolor=\"#DDDDDD\"><td><b>&nbsp;Album&nbsp;</b></td><td>&nbsp;<a href=\"$PHP_SELF?action=search&amp;search=do&amp;album=".urlencode($mp3info["album"])."\">".htmlentities($mp3info["album"])."</a>".($mp3info["track"]?" (Track ".$mp3info["track"].")":"")."&nbsp;</td></tr>";
		if($mp3info["year"]) echo "<tr bgcolor=\"#DDDDDD\"><td><b>&nbsp;Jahr&nbsp;</b></td><td>&nbsp;<a href=\"$PHP_SELF?action=search&amp;search=do&amp;year=".urlencode($mp3info["year"])."\">".htmlentities($mp3info["year"])."</a>&nbsp;</td></tr>";
		if($mp3info["genre"]) echo "<tr bgcolor=\"#DDDDDD\"><td><b>&nbsp;Genre&nbsp;</b></td><td>&nbsp;<a href=\"$PHP_SELF?action=search&amp;search=do&amp;genre=".urlencode($mp3info["genre"])."\">".htmlentities($GENRE[$mp3info["genre"]])."</a>&nbsp;</td></tr>";
		//if($mp3info["comment"]) echo "<tr bgcolor=\"#DDDDDD\"><td><b>&nbsp;Kommentar&nbsp;</b></td><td>&nbsp;".nl2br(htmlentities($mp3info["comment"]))."&nbsp;</td></tr>";
		if($mp3info["length"])
		{
			echo "<tr bgcolor=\"#DDDDDD\"><td colspan=\"2\">";
			echo "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" style=\"background-color:#6699CC; width:100%; height:10px;\" title=\"Laufzeit-Anzeige\"><tr><td>";
			echo "<div id=\"balken\" style=\"background-color:#003399; width:".floor(100 / $mp3info["length"] * (time()-$LASTBEGIN))."%; height:10px;\"></div>";
			echo "</td></tr></table>";
			echo "</td></tr>";
		}
		echo "<tr><td colspan=\"2\"><table border=\"0\"><tr><td width=\"350\">&nbsp;</td></tr></table></td></tr>";
		echo "</table>";

		echo "</td><td width=\"20\">&nbsp;</td><td style=\"vertical-align:top;\">";
		showSpeicherplatz($MP3DIR);
		echo "</td><td width=\"20\">&nbsp;</td><td style=\"vertical-align:top;\">";
		showVolumeBar();
		echo "</td>";
		echo "</tr></table>";

?>
<script type="text/javascript">
<!--

var SongTime = 0;
var SongRunningLoad = <?php echo time()-$LASTBEGIN; ?>;
var SongLength = <?php echo $mp3info["length"]; ?>;

function sec2min(sec)
{
	var tmp = sec/60;
	var teil2 = Math.floor(((tmp - Math.floor(tmp))*60)) + "";
	if(teil2.length<2) teil2 = "0" + teil2;
	return Math.floor(tmp) + ":" + teil2;
}


function Sekunde()
{
	window.setTimeout("Sekunde()",500);
	var SongRunning = (new Date().getTime() / 1000) - SongTime + SongRunningLoad;
	var SongRest = SongLength - SongRunning;
	if(SongRunning > SongLength) SongRunning = SongLength;
	if(SongRest < 0) SongRest = 0;
	var prozent = 100 / SongLength * SongRunning;
	if(prozent < 0) prozent = 0;
	if(prozent >= 100)
	{
		prozent = 100;
		window.setTimeout("location.reload()",1000);
	}
	document.getElementById("song_info_seit").firstChild.nodeValue = sec2min(SongRunning);
	document.getElementById("song_info_noch").firstChild.nodeValue = sec2min(SongRest);
	document.getElementById("balken").style.width = prozent + "%";
}

// Setzte Start-Zeit
SongTime = new Date().getTime() / 1000;
// Starte-Dynamische Funktion
Sekunde();
// Setzte Timeout fuer Reload
window.setTimeout("location.reload()",15000);

//-->
</script>
<?php
	}
	else
	{
		echo "<br />";
		echo "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\"><tr><td style=\"vertical-align:top;\">";
		showSpeicherplatz($MP3DIR);
		echo "</td><td width=\"50\">&nbsp;</td><td style=\"vertical-align:top;\">";
		showVolumeBar();
		echo "</td></tr></table>";
?>
<script type="text/javascript">
<!--

window.setTimeout("location.reload()",5000);

//-->
</script>
<?php
	}
	die($FOOT);
}
///////////////////////////////////////////////////////////////////////////////
//   P L A Y L I S T E   Z E I G E N                                         //
///////////////////////////////////////////////////////////////////////////////
elseif($action=="list")
{
	echo $HEAD; flush();
	$result = mysql_query("SELECT * FROM playlist ORDER BY nr") or die("\n<br /><b>MySQL-Fehler in Zeile ".__LINE__." (".__FILE__."): ".mysql_error().$FOOT);
	echo "<b>Playlist bearbeiten</b> (".mysql_num_rows($result)." Song(s))<br /><br />";
	// die wiederholung aendern
	if(isset($list) && $list=="repeat")
	{
		if(empty($HELD))
		{
			mysql_query("UPDATE playlist SET repeat='".($set?1:0)."' WHERE ".($repeat=="all"?"":"nr='".addslashes($nr)."' && ").(empty($HELD)||get_username()==$HELD?"1":"user='".get_username()."'")) or die("\n<br /><b>MySQL-Fehler in Zeile ".__LINE__." (".__FILE__."): ".mysql_error().$FOOT);
			if($repeat=="all") echo "Es wurden alle (".mysql_affected_rows().") Eintr&auml;ge modifiziert".(empty($HELD)?"":", die von deinem Computer hinzugef&uuml;gt wurden").".<br /><br />";
			else
			{
				if(mysql_affected_rows()) echo "Der Song wurde modifiziert.";
				else echo "Der Song konnte nicht modifiziert werden. Er wurde bereits entfernt oder wurde nicht von deinem Computer hinzugef&uuml;gt.";
				echo "<br /><br />";
			}
		}
		else
		{
			echo "Der MusicServer arbeitet im Helden-Modus. Hier ist eine Wiederholung eines Liedes nicht m&ouml;glich.";
		}
		back_button("action=list",array("link","meta"));
	// song(s) loeschen
	}
	elseif(isset($list) && $list=="delete")
	{
		mysql_query("DELETE FROM playlist WHERE ".($delete=="all"?"":"nr='".$nr."' && ").(empty($HELD) || get_username()==$HELD?"1":"user='".get_username()."'")) or die("\n<br /><b>MySQL-Fehler in Zeile ".__LINE__." (".__FILE__."): ".mysql_error().$FOOT);
		if($delete=="all") echo "Es wurden alle (".mysql_affected_rows().") Eintr&auml;ge gel&ouml;scht".(empty($HELD) || get_username()?"":", die von deinem Computer hinzugef&uuml;gt wurden").".<br /><br />";
		else
		{
			if(mysql_affected_rows()) echo "Der Song wurde aus der Playliste entfernt.";
			else echo "Der Song konnte nicht auch der Playliste entfernt werden. Er wurde bereits entfernt oder wurde nicht von deinem Computer hinzugef&uuml;gt.";
			echo "<br /><br />";
		}
		back_button("action=list",array("link","meta"));
	// speichern der playliste in einer m3u-datei
	}
	elseif(isset($list) && $list=="save")
	{
		if(mysql_num_rows($result))
		{
			$datei=trim($datei);
			if($datei)
			{
				if(strtolower(substr($datei,-4)!=".m3u")) $datei.=".m3u";
				$D = $MP3DIR.$datei;
				if(is_dir(dirname($D)))
				{
					if(is_writeable(dirname($D)))
					{
						if(basename($datei))
						{
							if(!file_exists($D) || $force)
							{
								$fp = fopen($D,"w");
								if($fp)
								{
									fputs($fp,"#EXTM3U\n");
									fputs($fp,"#KorelStar-MusicServer-Playlist - http://www.korelstar.de/musicserver/\n");
									while($row=mysql_fetch_array($result))
									{
										fputs($fp,$row["datei"]."\n");
									}
									fclose($fp);
									echo "Die Datei wurde erfolgreich geschrieben.<br />";
								} else echo "Die Datei konnte nicht ge&ouml;ffnet werden.";
							} else echo "Die Datei existiert bereits. Falls sie &uuml;berschrieben werden soll, bitte das entsprechende H&auml;kchen aktivieren.";
						} else echo "Es wurde keine Datei angegeben.";
					} else echo "In das angegebene Verzeichnis kann nicht geschrieben werden. Bitte Datei-Rechte &auml;ndern.";
				} else echo "Das angegebene Verzeichnis existiert nicht.";
			}
			else
			{
				// dateinamen angeben
				echo "<form method=\"get\" action=\"$PHP_SELF\" accept-charset=\"iso-8859-1\">";
				echo "<input type=\"hidden\" name=\"action\" value=\"list\" /><input type=\"hidden\" name=\"list\" value=\"save\" />";
				echo "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\"><tr><td colspan=\"2\">";
				echo "Speichern der Songs in folgende Datei: <input type=\"text\" size=\"30\" name=\"datei\" />.m3u <input type=\"submit\" value=\"OK\" /></td></tr>";
				echo "<tr><td><input type=\"checkbox\" name=\"force\" value=\"1\" /></td><td width=\"550\" class=\"klein\">Datei &uuml;berschreiben, falls vorhanden";
				echo "</td></tr></table></form>";
			}
		}
	}
	else
	{
		// dateinamen des letzten songs anzeigen
		$result_history = mysql_query("SELECT * FROM history ORDER BY datum DESC LIMIT 1");
		$row = mysql_fetch_array($result_history);
		$CUR = $row["datei"];
		$CURUSR = $row["user"];
		if($CUR)
		{
			echo "<b>Aktuell oder zuletzt gespielt:</b> ";
			echo "<a href=\"$PHP_SELF?action=add&amp;datei=".urlencode($CUR)."\">$CUR</a> ($CURUSR) <a href=\"$PHP_SELF?action=history\">History...</a><br />";
			echo "<br />";
		}
		// nun kommt die playliste..
		if(mysql_num_rows($result))
		{
			echo "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\">";
			echo "<tr><td colspan=\"3\" bgcolor=\"#666666\"><img src=\"blind.gif\" border=\"0\" width=\"1\" height=\"1\" alt=\"\" /></td></tr>";
			echo "<tr><td bgcolor=\"#666666\"><img src=\"blind.gif\" border=\"0\" width=\"1\" height=\"1\" alt=\"\" /></td>";
			// begin der oberen men-leiste
			echo "<td align=\"center\" bgcolor=\"#D4DDEE\"><table border=\"0\"><tr><td class=\"klein\">&nbsp;";
			echo "<b class=\"klein\">liste</b>";
			echo " [ <a href=\"$PHP_SELF?action=list&amp;list=delete&amp;delete=all\">leeren</a>";
			echo " | <a href=\"$PHP_SELF?action=list&amp;list=save\">speichern</a>";
			echo " ] ";
			if(empty($HELD))
			{
				echo "&amp; ";
				echo "<b class=\"klein\">wiederhohlen</b>";
				echo " [ <a href=\"$PHP_SELF?action=list&amp;list=repeat&amp;repeat=all&amp;set=1\">alle</a>";
				echo " | <a href=\"$PHP_SELF?action=list&amp;list=repeat&amp;repeat=all&amp;set=0\">keine</a>";
				echo " ]";
			}
			echo "&nbsp;</td></tr></table></td><td bgcolor=\"#666666\"><img src=\"blind.gif\" border=\"0\" width=\"1\" height=\"1\" alt=\"\" /></td></tr>";
			echo "<tr><td colspan=\"3\" bgcolor=\"#666666\"><img src=\"blind.gif\" border=\"0\" width=\"1\" height=\"1\" alt=\"\" /></td></tr>";
			echo "<tr><td bgcolor=\"#666666\"><img src=\"blind.gif\" border=\"0\" width=\"1\" height=\"1\" alt=\"\" /></td>";
			// beginn des mittleren feldes : playliste
			echo "<td bgcolor=\"#FFFFFF\">";
			$ps=10;
			settype($s,"integer");
			$mp = ceil(mysql_num_rows($result)/$ps)-1;
			if($s>$mp) $s=$mp;
			if($s<1) $s=0;
			mysql_data_seek($result,$s*$ps);
			echo "<table border=\"0\" width=\"100%\">";
			echo "<tr bgcolor=\"#CCCCCC\"><td align=\"right\"><b>id</b></td><td width=\"250\"><b>dateiname</b></td><td><b>repeat</b></td><td>&nbsp;</td><td><b>besitzer</b></td></tr>";
			for($i=0;$i<$ps && $row = mysql_fetch_array($result);$i++)
			{
				echo "<tr bgcolor=\"#".($i%2?"DDDDDD":"EEEEEE")."\"><td align=\"right\">".$row["nr"]."</td><td><a href=\"$PHP_SELF?action=add&amp;datei=".urlencode($row["datei"])."\" class=\"nobr\" title=\"".htmlentities($row["datei"])."\">".htmlentities(short($row["datei"]))."</a></td><td>".($row["repeat"]?"<b>":"<a href=\"$PHP_SELF?action=list&amp;list=repeat&amp;set=1&amp;nr=".$row["nr"]."\">")."yes".($row["repeat"]?"</b>":"</a>")."/".($row["repeat"]?"<a href=\"$PHP_SELF?action=list&amp;list=repeat&amp;set=0&amp;nr=".$row["nr"]."\">":"<b>")."no".($row["repeat"]?"</a>":"</b>")."</td><td><a href=\"$PHP_SELF?action=list&amp;list=delete&amp;nr=".$row["nr"]."\">delete</a></td><td>".$row["user"]."</td></tr>";
			}
			echo "</table></td><td bgcolor=\"#666666\"><img src=\"blind.gif\" border=\"0\" width=\"1\" height=\"1\" alt=\"\" /></td></tr>";
			echo "<tr><td colspan=\"3\" bgcolor=\"#666666\"><img src=\"blind.gif\" border=\"0\" width=\"1\" height=\"1\" alt=\"\" /></td></tr>";
			// beinn der unteren men-leiste
			echo "<tr><td bgcolor=\"#666666\"><img src=\"blind.gif\" border=\"0\" width=\"1\" height=\"1\" alt=\"\" /></td>";
			echo "<td align=\"center\" bgcolor=\"#D4DDEE\"><table border=\"0\"><tr><td class=\"klein\"><b class=\"klein\">[ ";
			if($s) echo " <a href=\"$PHP_SELF?action=list&amp;s=0\">&laquo; Anfang</a> | <a href=\"$PHP_SELF?action=list&amp;s=".($s-1)."\">&laquo; Zur&uuml;ck</a>";
			else echo "&laquo; Anfang | &laquo; Zur&uuml;ck";
			echo " ||";
			echo " <a href=\"$PHP_SELF?action=dir\">neu</a> ";
			echo "|| ";
			if($s<$mp) echo "<a href=\"$PHP_SELF?action=list&amp;s=".($s+1)."\">Weiter &raquo;</a> | <a href=\"$PHP_SELF?action=list&amp;s=$mp\">Ende &raquo;</a>";
			else echo "Weiter &raquo; | Ende &raquo;";
			echo " ]</b></td></tr></table></td><td bgcolor=\"#666666\"><img src=\"blind.gif\" border=\"0\" width=\"1\" height=\"1\" alt=\"\" /></td></tr>";
			echo "<tr><td colspan=\"3\" bgcolor=\"#666666\"><img src=\"blind.gif\" border=\"0\" width=\"1\" height=\"1\" alt=\"\" /></td></tr>";
			echo "</table>";
		}
		else
		{
			echo "<table border=\"0\" cellspacing=\"1\" cellpadding=\"0\">";
			echo "<tr><td valign=\"middle\"><img src=\"type_search.gif\" width=\"16\" height=\"16\" alt=\"Suchen\" /></td><td valign=\"middle\">&nbsp;<a href=\"$PHP_SELF?action=search\">Nach Songs suchen</a></td></tr>";
			echo "<tr><td valign=\"middle\"><img src=\"type_dir.gif\" width=\"16\" height=\"16\" alt=\"St&ouml;bern\" /></td><td valign=\"middle\">&nbsp;<a href=\"$PHP_SELF?action=dir\">In den Songs st&ouml;bern</a></td></tr>";
			echo "<tr><td valign=\"middle\"><img src=\"type_stat.gif\" width=\"16\" height=\"16\" alt=\"Charts\" /></td><td valign=\"middle\">&nbsp;<a href=\"$PHP_SELF?action=charts\">Charts</a></td></tr>";
			echo "<tr><td valign=\"middle\"><img src=\"type_historya.gif\" width=\"16\" height=\"16\" alt=\"History\" /></td><td valign=\"middle\">&nbsp;<a href=\"$PHP_SELF?action=history\">History</a></td></tr>";
			echo "</table>";
		}
	}
	die($FOOT);

}
///////////////////////////////////////////////////////////////////////////////
//   C H A R T S                                                             //
///////////////////////////////////////////////////////////////////////////////
elseif($action=="charts")
{
	echo $HEAD; flush();
	$CHARTS = array(
		"2 Wochen" => 14,
		"1 Monat" => 30,
		"1/4 Jahr" => 30*3,
		"Immer" => 0,
	);
	if(!isset($charts)) $charts=reset($CHARTS);
	settype($charts,"integer");
	if(isset($von)) echo "Charts von <b>".htmlentities($von)."</b>.<br /><br />";
	$result = mysql_query("SELECT datei,datum,count(datei) AS anzahl FROM history WHERE ".($charts>0?"datum>='".(time()-($charts*60*60*24))."'":"1")." && ".(isset($von)?"user='".$von."'":"1")." GROUP BY datei ORDER BY anzahl DESC, datum DESC") or die(mysql_error());

	echo "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\">";
	echo "<tr><td colspan=\"3\" bgcolor=\"#666666\"><img src=\"blind.gif\" border=\"0\" width=\"1\" height=\"1\" alt=\"\" /></td></tr>";
	echo "<tr><td bgcolor=\"#666666\"><img src=\"blind.gif\" border=\"0\" width=\"1\" height=\"1\" alt=\"\" /></td>";
	// begin der oberen men-leiste
	echo "<td align=\"center\" bgcolor=\"#D4DDEE\"><table border=\"0\"><tr><td class=\"klein\">&nbsp;";
	echo "<b class=\"klein\">charts</b>&nbsp;[&nbsp;";
	$n=0;
	foreach($CHARTS as $c_name => $c)
	{
		if($n) echo "|&nbsp;";
		if($charts==$c) echo $c_name; else echo "<a href=\"".$PHP_SELF."?action=charts&amp;charts=".$c.(isset($von)?"&amp;von=".urlencode($von):"")."\">".$c_name."</a>";
		echo "&nbsp;";
		$n=1;
	}
	echo "]";
	echo "&nbsp;</td></tr></table></td><td bgcolor=\"#666666\"><img src=\"blind.gif\" border=\"0\" width=\"1\" height=\"1\" alt=\"\" /></td></tr>";
	echo "<tr><td colspan=\"3\" bgcolor=\"#666666\"><img src=\"blind.gif\" border=\"0\" width=\"1\" height=\"1\" alt=\"\" /></td></tr>";
	echo "<tr><td bgcolor=\"#666666\"><img src=\"blind.gif\" border=\"0\" width=\"1\" height=\"1\" alt=\"\" /></td>";
	// beginn des mittleren feldes : playliste
	echo "<td bgcolor=\"#FFFFFF\">";
	echo "<table border=\"0\" width=\"100%\">";
	if(mysql_num_rows($result))
	{
		$ps=10;
		settype($s,"integer");
		$mp = ceil(mysql_num_rows($result)/$ps)-1;
		if($s>$mp) $s=$mp;
		if($s<1) $s=0;
		mysql_data_seek($result,$s*$ps);
		echo "<tr bgcolor=\"#CCCCCC\"><td align=\"right\"><b>anzahl</b></td><td width=\"250\"><b>dateiname</b></td><td><b>last play</b></td></tr>";
		for($i=0;$i<$ps && $row = mysql_fetch_array($result);$i++)
		{
			echo "<tr bgcolor=\"#".($i%2?"DDDDDD":"EEEEEE")."\"><td align=\"right\">".$row["anzahl"]."</td><td><a href=\"$PHP_SELF?action=add&amp;datei=".urlencode($row["datei"])."\" class=\"nobr\" title=\"".htmlentities($row["datei"])."\">".htmlentities(short($row["datei"]))."</a></td><td class=\"nobr\">".date("d.m.Y H:i:s",$row["datum"])."</td></tr>";
		}
	}
	else
	{
		echo "<tr bgcolor=\"#EEEEEE\"><td align=\"center\">In dem gew&auml;hlten Zeitraum wurden keine Lieder abgespielt.</td></tr>";
	}
	echo "</table>";
	echo "</td><td bgcolor=\"#666666\"><img src=\"blind.gif\" border=\"0\" width=\"1\" height=\"1\" alt=\"\" /></td></tr>";
	echo "<tr><td colspan=\"3\" bgcolor=\"#666666\"><img src=\"blind.gif\" border=\"0\" width=\"1\" height=\"1\" alt=\"\" /></td></tr>";
	// beinn der unteren men-leiste
	echo "<tr><td bgcolor=\"#666666\"><img src=\"blind.gif\" border=\"0\" width=\"1\" height=\"1\" alt=\"\" /></td>";
	echo "<td align=\"center\" bgcolor=\"#D4DDEE\"><table border=\"0\"><tr><td class=\"klein\"><b class=\"klein\">[ ";
	if($s) echo " <a href=\"$PHP_SELF?action=charts".(isset($von)?"&amp;von=".urlencode($von):"")."&amp;s=0\">&laquo; Anfang</a> | <a href=\"$PHP_SELF?action=charts".(isset($von)?"&amp;von=".urlencode($von):"")."&amp;charts=$charts&amp;s=".($s-1)."\">&laquo; Zur&uuml;ck</a>";
	else echo "&laquo; Anfang | &laquo; Zur&uuml;ck";
	echo " ||";
	echo " <a href=\"$PHP_SELF?action=dir\">neu</a> ";
	echo "|| ";
	if($s<$mp) echo "<a href=\"$PHP_SELF?action=charts".(isset($von)?"&amp;von=".urlencode($von):"")."&amp;charts=$charts&amp;s=".($s+1)."\">Weiter &raquo;</a> | <a href=\"$PHP_SELF?action=charts".(isset($von)?"&amp;von=".urlencode($von):"")."&amp;charts=$charts&amp;s=$mp\">Ende &raquo;</a>";
	else echo "Weiter &raquo; | Ende &raquo;";
	echo " ]</b></td></tr></table></td><td bgcolor=\"#666666\"><img src=\"blind.gif\" border=\"0\" width=\"1\" height=\"1\" alt=\"\" /></td></tr>";
	echo "<tr><td colspan=\"3\" bgcolor=\"#666666\"><img src=\"blind.gif\" border=\"0\" width=\"1\" height=\"1\" alt=\"\" /></td></tr>";
	echo "</table>";
	/*else
	{
		echo "<table border=\"0\" cellspacing=\"1\" cellpadding=\"0\">";
		echo "<tr><td valign=\"middle\"><img src=\"type_search.gif\" width=\"16\" height=\"16\" alt=\"Suchen\" /></td><td valign=\"middle\">&nbsp;<a href=\"$PHP_SELF?action=search\">Nach Songs suchen</a></td></tr>";
		echo "<tr><td valign=\"middle\"><img src=\"type_dir.gif\" width=\"16\" height=\"16\" alt=\"Stbern\" /></td><td valign=\"middle\">&nbsp;<a href=\"$PHP_SELF?action=dir\">In den Songs st&ouml;bern</a></td></tr>";
		echo "<tr><td valign=\"middle\"><img src=\"type_historya.gif\" width=\"16\" height=\"16\" alt=\"History\" /></td><td valign=\"middle\">&nbsp;<a href=\"$PHP_SELF?action=history\">History</a></td></tr>";
		echo "</table>";
	}*/
	die($FOOT);
}
///////////////////////////////////////////////////////////////////////////////
//   H I S T O R Y                                                           //
///////////////////////////////////////////////////////////////////////////////
elseif($action=="history")
{
	echo $HEAD; flush();
	$result = mysql_query("SELECT * FROM history ORDER BY datum DESC");
	if(mysql_num_rows($result))
	{
		echo "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\">";
		echo "<tr><td colspan=\"3\" bgcolor=\"#666666\"><img src=\"blind.gif\" border=\"0\" width=\"1\" height=\"1\" alt=\"\" /></td></tr>";
		echo "<tr><td bgcolor=\"#666666\"><img src=\"blind.gif\" border=\"0\" width=\"1\" height=\"1\" alt=\"\" /></td>";
		// begin der oberen men-leiste
		echo "<td align=\"center\" bgcolor=\"#D4DDEE\"><table border=\"0\"><tr><td class=\"klein\">&nbsp;";
		echo "<b class=\"klein\">history</b>";
		echo "&nbsp;</td></tr></table></td><td bgcolor=\"#666666\"><img src=\"blind.gif\" border=\"0\" width=\"1\" height=\"1\" alt=\"\" /></td></tr>";
		echo "<tr><td colspan=\"3\" bgcolor=\"#666666\"><img src=\"blind.gif\" border=\"0\" width=\"1\" height=\"1\" alt=\"\" /></td></tr>";
		echo "<tr><td bgcolor=\"#666666\"><img src=\"blind.gif\" border=\"0\" width=\"1\" height=\"1\" alt=\"\" /></td>";
		// beginn des mittleren feldes : playliste
		echo "<td bgcolor=\"#FFFFFF\">";
		$ps=10;
		settype($s,"integer");
		$mp = ceil(mysql_num_rows($result)/$ps)-1;
		if($s>$mp) $s=$mp;
		if($s<1) $s=0;
		mysql_data_seek($result,$s*$ps);
		echo "<table border=\"0\" width=\"100%\">";
		echo "<tr bgcolor=\"#CCCCCC\"><td align=\"right\"><b>id</b></td><td width=\"250\"><b>dateiname</b></td><td><b>datum</b></td><td><b>besitzer</b></td></tr>";
		for($i=0;$i<$ps && $row = mysql_fetch_array($result);$i++)
		{
			echo "<tr bgcolor=\"#".($i%2?"DDDDDD":"EEEEEE")."\"><td align=\"right\">".$row["nr"]."</td><td><a href=\"$PHP_SELF?action=add&amp;datei=".urlencode($row["datei"])."\" class=\"nobr\" title=\"".htmlentities($row["datei"])."\">".htmlentities(short($row["datei"]))."</a></td><td class=\"nobr\">".date("d.m.Y H:i:s",$row["datum"])."</td><td>".htmlentities($row["user"])."</td></tr>";
		}
		echo "</table></td><td bgcolor=\"#666666\"><img src=\"blind.gif\" border=\"0\" width=\"1\" height=\"1\" alt=\"\" /></td></tr>";
		echo "<tr><td colspan=\"3\" bgcolor=\"#666666\"><img src=\"blind.gif\" border=\"0\" width=\"1\" height=\"1\" alt=\"\" /></td></tr>";
		// beinn der unteren men-leiste
		echo "<tr><td bgcolor=\"#666666\"><img src=\"blind.gif\" border=\"0\" width=\"1\" height=\"1\" alt=\"\" /></td>";
		echo "<td align=\"center\" bgcolor=\"#D4DDEE\"><table border=\"0\"><tr><td class=\"klein\"><b class=\"klein\">[ ";
		if($s) echo " <a href=\"$PHP_SELF?action=history&amp;s=0\">&laquo; Anfang</a> | <a href=\"$PHP_SELF?action=history&amp;s=".($s-1)."\">&laquo; Zur&uuml;ck</a>";
		else echo "&laquo; Anfang | &laquo; Zur&uuml;ck";
		echo " ||";
		echo " <a href=\"$PHP_SELF?action=dir\">neu</a> ";
		echo "|| ";
		if($s<$mp) echo "<a href=\"$PHP_SELF?action=history&amp;s=".($s+1)."\">Weiter &raquo;</a> | <a href=\"$PHP_SELF?action=history&amp;s=$mp\">Ende &raquo;</a>";
		else echo "Weiter &raquo; | Ende &raquo;";
		echo " ]</b></td></tr></table></td><td bgcolor=\"#666666\"><img src=\"blind.gif\" border=\"0\" width=\"1\" height=\"1\" alt=\"\" /></td></tr>";
		echo "<tr><td colspan=\"3\" bgcolor=\"#666666\"><img src=\"blind.gif\" border=\"0\" width=\"1\" height=\"1\" alt=\"\" /></td></tr>";
		echo "</table>";
	}
	else
	{
		echo "<table border=\"0\" cellspacing=\"1\" cellpadding=\"0\">";
		echo "<tr><td valign=\"middle\"><img src=\"type_search.gif\" width=\"16\" height=\"16\" alt=\"Suchen\" /></td><td valign=\"middle\">&nbsp;<a href=\"$PHP_SELF?action=search\">Nach Songs suchen</a></td></tr>";
		echo "<tr><td valign=\"middle\"><img src=\"type_dir.gif\" width=\"16\" height=\"16\" alt=\"Stbern\" /></td><td valign=\"middle\">&nbsp;<a href=\"$PHP_SELF?action=dir\">In den Songs st&ouml;bern</a></td></tr>";
		echo "<tr><td valign=\"middle\"><img src=\"type_stat.gif\" width=\"16\" height=\"16\" alt=\"Charts\" /></td><td valign=\"middle\">&nbsp;<a href=\"$PHP_SELF?action=charts\">Charts</a></td></tr>";
		echo "</table>";
	}
	die($FOOT);

}
///////////////////////////////////////////////////////////////////////////////
//   S U C H E                                                               //
///////////////////////////////////////////////////////////////////////////////
elseif($action=="search")
{
	echo $HEAD; flush();
	// update der such-db mit cron_db.php
	if($search=="update")
	{
		echo "<font size=\"3\"><pre>";
		include("cron/cron_db.php");
		echo "</pre></font>";
		back_button("action=search",array("meta","link"));
	}
	else
	{
		echo "<b>Suche</b><br />";
		echo "<br />";
		// such-formular
		echo "<form method=\"get\" action=\"$PHP_SELF\" accept-charset=\"iso-8859-1\"><input type=\"hidden\" name=\"action\" value=\"search\" /><input type=\"hidden\" name=\"search\" value=\"do\" />";
		echo "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" bgcolor=\"#EEEEEE\">";
		echo "<tr><td colspan=\"3\" bgcolor=\"#666666\"><img src=\"blind.gif\" border=\"0\" width=\"1\" height=\"1\" alt=\"\" /></td></tr>";
		echo "<tr><td bgcolor=\"#666666\"><img src=\"blind.gif\" border=\"0\" width=\"1\" height=\"1\" alt=\"\" /></td>";
		echo "<td><table border=\"0\"><tr><td>";
		echo "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\">";
		echo "<tr><td>"."Song&nbsp;</td><td><input type=\"text\" name=\"song\" value=\"".htmlentities($song)."\" /></td></tr>";
		echo "<tr><td>"."Artist&nbsp;</td><td><input type=\"text\" name=\"artist\" value=\"".htmlentities($artist)."\" /></td></tr>";
		echo "<tr><td>"."Genre&nbsp;</td><td><select name=\"genre\"><option value=\"\">[ALLE]</option>";
		for(reset($GENRE); list($key,$val)=each($GENRE);)
		{
			echo "<option value=\"".$key."\"".(!empty($genre) && $genre==$key?" selected=\"selected\"":"").">".htmlentities($val)."</option>";
		}
		echo "</select></td></tr>";
		echo "</table></td><td><table border=\"0\" cellpadding=\"0\" cellspacing=\"0\">";
		echo "<tr><td>"."Album&nbsp;</td><td><input type=\"text\" name=\"album\" value=\"".htmlentities($album)."\" /></td></tr>";
		echo "<tr><td>"."Jahr&nbsp;</td><td><input type=\"text\" name=\"year\" value=\"".htmlentities($year)."\" /></td></tr>";
		echo "<tr><td>&nbsp;</td><td align=\"right\"><input type=\"submit\" value=\"Suchen\" /></td></tr>";
		echo "</table>";
		echo "</td></tr></table></td>";
		echo "<td bgcolor=\"#666666\"><img src=\"blind.gif\" border=\"0\" width=\"1\" height=\"1\" alt=\"\" /></td></tr>";
		echo "<tr><td colspan=\"3\" bgcolor=\"#666666\"><img src=\"blind.gif\" border=\"0\" width=\"1\" height=\"1\" alt=\"\" /></td></tr>";
		echo "</table>";
		echo "</form>";
		echo "<br />";
		// suche!
		if($search=="do")
		{
			echo "<br />";
			// erstellen des db-querys
			$suche = array();
			$suche["song"] = split_suche($song);
			$suche["artist"] = split_suche($artist);
			$suche["album"] = split_suche($album);
			$where_query = "status='1'";
			if($genre && $genre!="") $where_query .= " && genre='".addslashes($genre)."' ";
			if($year) $where_query .= " && year LIKE '".addslashes($year)."%' ";
			while(list($spalte,$wortsuche)=each($suche))
			{
				for($i=0;$i<2;$i++)
				{
					$not = $i ? "":"NOT";
					$bool = $i ? "||":"&&";
					while(list(,$wort)=each($wortsuche[$i]))
					{
						$wort = trim($wort);
						if($wort) $where_query .= " && ($spalte $not LIKE '%".addslashes($wort)."%')";
					}
				}
			}
			$result = mysql_query("SELECT datei FROM songs WHERE $where_query ORDER BY datei") or die("MySQL-Fehler in Zeile ".__LINE__.": ".mysql_error());
			// ausgabe!
			if(mysql_num_rows($result))
			{
				if(mysql_num_rows($result)==1) echo "Es wurde ein Song gefunden.<br />";
				else echo "Es wurden ".mysql_num_rows($result)." Songs gefunden.<br />";
				echo "<br />";
				flush();
				echo "<form method=\"post\" action=\"$PHP_SELF\" accept-charset=\"iso-8859-1\"><input type=\"hidden\" name=\"action\" value=\"add\" /><input type=\"hidden\" name=\"add\" value=\"do\" /><input type=\"hidden\" name=\"datei\" value=\"".htmlentities($datei)."\" />";
				echo "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\"><tr><td>";
				echo "<table border=\"0\">";
				echo "<tr bgcolor=\"#D4DDEE\"><td>&nbsp;</td><td><b>&nbsp;Pfad&nbsp;</b></td><td><b>&nbsp;Artist&nbsp;</b></td><td><b>&nbsp;Song&nbsp;</b></td></tr>";
				$ps = 20;
				settype($p,"integer");
				$mp = ceil(mysql_num_rows($result)/$ps);
				if($p>$mp) $p=$mp;
				if($p<1) $p=0;
				mysql_data_seek($result,$p*$ps);
				for($i=0;$i<$ps && $row = mysql_fetch_array($result);$i++)
				{
					$cur = $row["datei"];
					$mp3info = mp3_getinfo($cur);
					echo "<tr bgcolor=\"#".($i%2?"DDDDDD":"EEEEEE")."\">";
					echo "<td>&nbsp;<input type=\"checkbox\" name=\"song[".$i."]\" value=\"1\" checked=\"checked\" id=\"song_".$i."\" /><input type=\"hidden\" name=\"songdatei[".$i."]\" value=\"".htmlentities($cur)."\" />&nbsp;</td>";
					echo "<td>&nbsp;<a href=\"$PHP_SELF?action=add&amp;datei=".urlencode($cur)."\" class=\"nobr\" title=\"".htmlentities($cur)."\">".htmlentities(short($cur))."</a>&nbsp;</td>";
					echo "<td>&nbsp;<label for=\"song_".$i."\">".htmlentities(trim($mp3info["artist"]))."</label>&nbsp;</td>";
					echo "<td>&nbsp;<label for=\"song_".$i."\">".htmlentities(trim($mp3info["song"]))."</label>&nbsp;</td>";
					echo "</tr>";
				}
				$back = $p-1;
				$fore = $p+1;
				$query = "action=search&amp;search=do&amp;song=".urlencode($song)."&amp;artist=".urlencode($artist)."&amp;album=".urlencode($album)."&amp;year=".urlencode($year)."&amp;genre=".urlencode($genre);
				echo "<tr bgcolor=\"#D4DDEE\"><td colspan=\"4\" align=\"center\"><b>&nbsp;&laquo;";
				echo $p ? "<a href=\"$PHP_SELF?$query&amp;p=$back\">Zur&uuml;ck</a>" : "Zur&uuml;ck";
				echo " | ";
				echo $fore<$mp ? "<a href=\"$PHP_SELF?$query&amp;p=$fore\">Weiter</a>" : "Weiter";
				echo "&raquo;&nbsp;</b></td></tr>";
				echo "</table>";
				echo "<br />";
				// hinzufuegen zur playliste
				echo $str_form_addsong;
				echo "</td></tr></table></form><br />";
			}
			else
			{
				echo "<b>Keine Songs gefunden</b><br />";
				$info=1;
			}
		} else $info=1;
		// krasser info-text
		if($info)
		{
			echo "<br />";
			echo "Die Suche unterst&uuml;tzt die Zeichen + und - zur Angabe<br />";
			echo "ob das folgende Wort vorkommen muss oder nicht darf.<br />";
			echo "Wird kein Zeichen angegeben, so wird + verwendet.<br />";
			echo "<br />";
			echo "Ebenso k&ouml;nnen mehrere W&ouml;rter in Anf&uuml;hrungszeichen gesetzt<br />";
			echo "werden, um zu definieren, dass der gesamte Ausdruck in dieser<br />";
			echo "Reihenfolge gemeint ist.<br />";
			echo "<br />";
			echo "Die Sonderzeichen &quot;%&quot; und &quot;_&quot; k&ouml;nnen verwendet werden.<br />";
			echo "&quot;%&quot; stellt beliebig viele Zeichen dar und &quot;_&quot; genau ein beliebiges<br />";
			echo "Zeichen. Somit kann mit &quot;-_&quot; nach einem leeren Feld gesucht<br />";
			echo "werden.<br />";
			echo "<br />";
			echo "Die Suche basiert auf einer Datenbank, die jede Nacht aktualisiert<br />";
			echo "wird. Falls nach dem letzten Update viele MP3s verschoben,<br />";
			echo "hinzugef&uuml;gt oder gel&ouml;scht wurden, lohnt es sich, ein<br />";
			echo "<a href=\"$PHP_SELF?action=search&amp;search=update\">manuelles Update</a> durchzuf&uuml;hren. Hierbei werden die ID3-Tags<br />";
			echo "der MP3-Dateien ausgelesen. Sind diese bei einer Datei nicht<br />";
			echo "gesetzt, kann sie auch nicht gefunden werden.<br />";
		}
	}
	die($FOOT);


}
///////////////////////////////////////////////////////////////////////////////
//   S O N G / V E R Z E I C H N I S    H I N Z U F  G E N                  //
///////////////////////////////////////////////////////////////////////////////
elseif($action=="add")
{
	if(!is_readable($MP3DIR.$datei))
	{
		// fehlerausgabe
		echo $HEAD;
		echo "Die gew&auml;hlte Datei &quot;$datei&quot; ist nicht lesbar. Dies kann folgende Ursachen haben:<br />";
		echo "- Die Datei existiert nicht mehr<br />";
		echo "- Dateirechte sind falsch gesetzt (der Webserver ben&ouml;tigt Lese-Rechte)<br />";
		echo "- Im Dateinamen sind Sonderzeichen vorhanden (z.B. Hochkomma)<br />";
		echo "<br />";
		echo "<a href=\"$PHP_SELF?action=dir\">Zu den Dateien</a> | <a href=\"$PHP_SELF?action=list\">Zur Playliste</a><br />";
		die($FOOT);
	}
	if(is_file($MP3DIR.$datei) && strtolower(substr($MP3DIR.$datei,-4))==".mp3")
	{
		// einzelne datei adden
		if($add=="do")
		{
			if($wo=="local" && $SAMBA) send_m3u($datei);
			echo $HEAD."<b>".dir_str($datei)."</b><br /><br />";
			song_add($datei,$repeat,$pos);
			echo "<br />";
			echo "<a href=\"$PHP_SELF?action=dir\">Zu den Dateien</a> | <a href=\"$PHP_SELF?action=list\">Zur Playliste</a><br />";
		}
		else
		{
			echo $HEAD."<b>".dir_str($datei)."</b><br /><br />";
			// info-formular
			$mp3info = mp3_getinfo($datei,1,1);
			if($mp3info)
			{
				echo "<table border=\"0\" cellpadding=\"2\" cellspacing=\"2\">";
				echo "<tr bgcolor=\"#D4DDEE\"><td colspan=\"2\"><b>&nbsp;Details&nbsp;</b>".(is_writeable($MP3DIR.$datei)?"(<a href=\"$PHP_SELF?action=file&amp;file=id3&amp;datei=".urlencode($datei)."\">Bearbeiten</a>)":"<i>schreibgesch&uuml;tzt</i>")."&nbsp;</td></tr>";
				if($mp3info["size"]) echo "<tr bgcolor=\"#DDDDDD\"><td><b>&nbsp;Gr&ouml;&szlig;e&nbsp;</b></td><td>&nbsp;".number_format($mp3info["size"]/1024/1024,2)."&nbsp;MB&nbsp;</td></tr>";
				if($mp3info["length"]) echo "<tr bgcolor=\"#DDDDDD\"><td><b>&nbsp;L&auml;nge&nbsp;</b></td><td>&nbsp;".sec2min($mp3info["length"])."&nbsp;Min&nbsp;</td></tr>";
				if($mp3info["frequency"]) echo "<tr bgcolor=\"#DDDDDD\"><td><b>&nbsp;Sample-Frequ.&nbsp;</b></td><td>&nbsp;".$mp3info["frequency"]."&nbsp;Hz&nbsp;</td></tr>";
				if($mp3info["bitrate"]) echo "<tr bgcolor=\"#DDDDDD\"><td><b>&nbsp;Bit-Rate&nbsp;</b></td><td>&nbsp;".$mp3info["bitrate"]."&nbsp;KBit/s&nbsp;</td></tr>";
				if($mp3info["mode"]) echo "<tr bgcolor=\"#DDDDDD\"><td><b>&nbsp;Mode&nbsp;</b></td><td>&nbsp;".$mp3info["mode"]."&nbsp;</td></tr>";
				if($mp3info["mpeg"] && $mp3info["layer"]) echo "<tr bgcolor=\"#DDDDDD\"><td><b>&nbsp;Typ&nbsp;</b></td><td>&nbsp;MPEG-".$mp3info["mpeg"]."&nbsp;Layer&nbsp;".$mp3info["layer"]."&nbsp;</td></tr>";
				if($mp3info["artist"]) echo "<tr bgcolor=\"#DDDDDD\"><td><b>&nbsp;Artist&nbsp;</b></td><td>&nbsp;<a href=\"$PHP_SELF?action=search&amp;search=do&amp;artist=".urlencode($mp3info["artist"])."\">".htmlentities($mp3info["artist"])."</a>&nbsp;</td></tr>";
				if($mp3info["song"]) echo "<tr bgcolor=\"#DDDDDD\"><td><b>&nbsp;Song&nbsp;</b></td><td>&nbsp;<a href=\"$PHP_SELF?action=search&amp;search=do&amp;song=".urlencode($mp3info["song"])."\">".htmlentities($mp3info["song"])."</a>&nbsp;</td></tr>";
				if($mp3info["album"]) echo "<tr bgcolor=\"#DDDDDD\"><td><b>&nbsp;Album&nbsp;</b></td><td>&nbsp;<a href=\"$PHP_SELF?action=search&amp;search=do&amp;album=".urlencode($mp3info["album"])."\">".htmlentities($mp3info["album"])."</a>".($mp3info["track"]?" (Track ".$mp3info["track"].")":"")."&nbsp;</td></tr>";
				if($mp3info["year"]) echo "<tr bgcolor=\"#DDDDDD\"><td><b>&nbsp;Jahr&nbsp;</b></td><td>&nbsp;<a href=\"$PHP_SELF?action=search&amp;search=do&amp;year=".urlencode($mp3info["year"])."\">".htmlentities($mp3info["year"])."</a>&nbsp;</td></tr>";
				if($mp3info["genre"]) echo "<tr bgcolor=\"#DDDDDD\"><td><b>&nbsp;Genre&nbsp;</b></td><td>&nbsp;<a href=\"$PHP_SELF?action=search&amp;search=do&amp;genre=".urlencode($mp3info["genre"])."\">".htmlentities($GENRE[$mp3info["genre"]])."</a>&nbsp;</td></tr>";
				if($mp3info["comment"]) echo "<tr bgcolor=\"#DDDDDD\"><td><b>&nbsp;Kommentar&nbsp;</b></td><td>&nbsp;".nl2br(htmlentities($mp3info["comment"]))."&nbsp;</td></tr>";
				echo "</table>";
				echo "<br />";
			}
			// add-formular
			echo "<form method=\"post\" action=\"$PHP_SELF\" accept-charset=\"iso-8859-1\"><input type=\"hidden\" name=\"action\" value=\"add\" /><input type=\"hidden\" name=\"add\" value=\"do\" /><input type=\"hidden\" name=\"datei\" value=\"".htmlentities($datei)."\" />";
			echo "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\"><tr><td>";
			echo $str_form_addsong;
			echo "</td></tr></table></form><br />";
		}
		die($FOOT);
	// playlist oder verzeichnis adden
	}
	elseif((is_file($MP3DIR.$datei) && strtolower(substr($MP3DIR.$datei,-4))==".m3u") || is_dir($MP3DIR.$datei))
	{
		$DATEIEN = array();
		// fuer beide faelle die daten ausgeben
		if($add=="do")
		{
			if(is_array($song) && count($song))
			{
				while(list($key,$val)=each($song))
				{
					if($val && $songdatei[$key]) $DATEIEN[] = stripslashes($songdatei[$key]);
				}
				if($wo=="local" && $SAMBA) // lokales Abspielen
				{
					send_m3u($DATEIEN);
				}
				echo $HEAD."<b>".dir_str($datei)."</b><br /><br />";
				if($wo=="id3_edit") // ID3-Tags der Dateien ndern
				{
					foreach($DATEIEN as $cur)
					{
						$mp3info = mp3_getinfo($cur);
						// Wenn ID3v2 vorher nicht vorhanden war, dann Variablen leeren
						if(!$mp3info["id3v2"])
						{
							unset($mp3info["song"]);
							unset($mp3info["artist"]);
							unset($mp3info["album"]);
							unset($mp3info["track"]);
							unset($mp3info["soyear"]);
							unset($mp3info["genre"]);
							unset($mp3info["comment"]);
						}
						// Variablen ndern, wenn verlangt
						if($titel_check) $mp3info["id3song"] = $mp3info["song"] = $titel;
						if($artist_check) $mp3info["id3artist"] = $mp3info["artist"] = $artist;
						if($album_check) $mp3info["id3album"] = $mp3info["album"] = $album;
						if($track_check) $mp3info["id3track"] = $mp3info["track"] = $track;
						if($jahr_check) $mp3info["id3year"] = $mp3info["year"] = $year;
						if($genre_check) $mp3info["id3genre"] = $mp3info["genre"] = $genre;
						if($comment_check) $mp3info["id3comment"] = $mp3info["comment"] = $comment;
						// Tags Speichern, entfernen oder lassen
						if($id3v1=="edit") id3v1save($cur,$mp3info["id3song"],$mp3info["id3artist"],$mp3info["id3album"],$mp3info["id3year"],$mp3info["id3comment"],$mp3info["id3track"],$mp3info["id3genre"]);
						if($id3v2=="edit") id3v2save($cur,$mp3info["song"],   $mp3info["artist"],   $mp3info["album"],   $mp3info["year"],   $mp3info["comment"],   $mp3info["track"],   $mp3info["genre"]);
						if($id3v1=="delete") id3v1remove($cur);
						if($id3v2=="delete") id3v2remove($cur);
						flush();
					}
				}
				else // normales hinzufgen
				{
					$anzahl = song_add($DATEIEN,$repeat,$pos);
					echo "<br />";
					echo "Es wurden $anzahl Dateien hinzugef&uuml;gt.<br />";
				}
			}
			else
			{
				echo $HEAD."<b>".dir_str($datei)."</b><br /><br />";
				echo "Es wurden keine Songs ausgew&auml;hlt.<br />";
			}
			echo "<br />";
			echo "<a href=\"$PHP_SELF?action=dir\">Zu den Dateien</a> | <a href=\"$PHP_SELF?action=list\">Zur Playliste</a><br />";
		}
		else
		{
			echo $HEAD."<b>".dir_str($datei)."</b><br /><br />"; flush();
			// komplettes verzeichnis adden
			if(is_dir($MP3DIR.$datei))
			{
				$verz = dir($MP3DIR.$datei);
				while($row = $verz->read())
				{
					if(substr($row,0,1)!="." && strtolower(substr($row,-4))==".mp3")
					{
						$DATEIEN[] = ($datei?$datei."/":"").$row;
					}
				}
				$verz->close();
				sort($DATEIEN);
			// komplette playliste adden
			} elseif(is_file($MP3DIR.$datei) && strtolower(substr($MP3DIR.$datei,-4))==".m3u")
			{
				$fp = fopen($MP3DIR.$datei,"r");
				if($fp)
				{
					while(!feof($fp))
					{
						$zeile = trim(fgets($fp,1024));
						if($zeile && substr($zeile,0,1)!="#")
						{
							$DATEIEN[] = str_replace("\\","/",$zeile);
						}
					}
				}
				else echo "Die Playliste konnte nicht ausgelesen werden.<br />";
			}
			// ausgeben der verzeichnis-liste
			$fehler = 0;
			$str  = "<table border=\"0\">";
			$str .= "<tr bgcolor=\"#D4DDEE\"><td>&nbsp;</td><td><b>&nbsp;Pfad&nbsp;</b></td><td><b>&nbsp;Artist&nbsp;</b></td><td><b>&nbsp;Song&nbsp;</b></td></tr>";
			$fehlerhaft = "";
			for($i=0;list(,$cur)=each($DATEIEN);$i++)
			{
				set_time_limit(30);
				$mp3info = mp3_getinfo($cur);
				if($mp3info)
				{
					$str .= "<tr bgcolor=\"#".($i%2?"DDDDDD":"EEEEEE")."\"><td>&nbsp;<input type=\"checkbox\" name=\"song[$i]\" value=\"1\" checked=\"checked\" /><input type=\"hidden\" name=\"songdatei[$i]\" value=\"".htmlentities($cur)."\" />&nbsp;</td><td>&nbsp;<a href=\"$PHP_SELF?action=add&amp;datei=".urlencode($cur)."\" class=\"nobr\" title=\"".htmlentities($cur)."\">".htmlentities(short($cur))."</a>&nbsp;</td><td>&nbsp;".$mp3info["artist"]."&nbsp;</td><td>&nbsp;".$mp3info["song"]."&nbsp;</td></tr>";
				}
				else
				{
					if($showerror)
					{
						$fehlerhaft .= "Datei nicht gefunden: ".$cur."<br />";
					}
					$fehler++;
				}
			}
			$str .= "</table>";
			// formular zum hinzufuegen ausgeben
			if(count($DATEIEN)-$fehler>0)
			{
				echo "Dateien gefunden: ".count($DATEIEN).($fehler?", davon $fehler <a href=\"$PHP_SELF?action=add&amp;datei=".urlencode($datei)."&amp;showerror=1\" title=\"Zeige die fehlerhaften Eintrge\">fehlerhaft</a>":"")."<br />";
				if($fehlerhaft) echo "<br />".$fehlerhaft;
				echo "<br />";
				echo "<form method=\"post\" action=\"$PHP_SELF\" accept-charset=\"iso-8859-1\"><input type=\"hidden\" name=\"action\" value=\"add\" /><input type=\"hidden\" name=\"add\" value=\"do\" /><input type=\"hidden\" name=\"datei\" value=\"".htmlentities($datei)."\" />";
				echo "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\"><tr><td>";
				echo $str;
				echo "<br />";
				if($add=="id3")
				{
					echo "<input type=\"hidden\" name=\"wo\" value=\"id3_edit\" />";
					echo "<br />";
					echo "<table border=\"0\" cellpadding=\"2\" cellspacing=\"2\">";
					echo "<tr bgcolor=\"#D4DDEE\"><td colspan=\"3\"><b>ID3-Tag f&uuml;r o.g. Dateien modifizieren</b></td></tr>";
					echo "<tr bgcolor=\"#DDDDDD\"><td><input type=\"checkbox\" name=\"titel_check\" value=\"1\" id=\"titel_check\" />&nbsp;<label for=\"titel_check\"><b>Song</b></label></td><td><input name=\"titel\" size=\"25\" value=\"\" onchange=\"document.forms[0].titel_check.checked=true;\" onfocus=\"document.forms[0].titel_check.checked=true;\" tabindex=\"1\" style=\"width:250px;\" /></td></tr>";
					echo "<tr bgcolor=\"#DDDDDD\"><td><input type=\"checkbox\" name=\"artist_check\" value=\"1\" id=\"artist_check\" />&nbsp;<label for=\"artist_check\"><b>Artist</b></label></td><td><input name=\"artist\" size=\"25\" value=\"\" onchange=\"document.forms[0].artist_check.checked=true;\" onfocus=\"document.forms[0].artist_check.checked=true;\" tabindex=\"2\" style=\"width:250px;\" /></td></tr>";
					echo "<tr bgcolor=\"#DDDDDD\"><td><input type=\"checkbox\" name=\"album_check\" value=\"1\" id=\"album_check\" />&nbsp;<label for=\"album_check\"><b>Album</b></label></td><td><input name=\"album\" size=\"25\" value=\"\" onchange=\"document.forms[0].album_check.checked=true;\" onfocus=\"document.forms[0].album_check.checked=true;\" tabindex=\"3\" style=\"width:250px;\" /></td></tr>";
					echo "<tr bgcolor=\"#DDDDDD\"><td><input type=\"checkbox\" name=\"track_check\" value=\"1\" id=\"track_check\" />&nbsp;<label for=\"track_check\"><b>Track</b></label></td><td><input name=\"track\" size=\"6\" maxlength=\"2\" value=\"\" onchange=\"document.forms[0].track_check.checked=true;\" onfocus=\"document.forms[0].track_check.checked=true;\" tabindex=\"4\" /></td></tr>";
					echo "<tr bgcolor=\"#DDDDDD\"><td><input type=\"checkbox\" name=\"jahr_check\" value=\"1\" id=\"jahr_check\" />&nbsp;<label for=\"jahr_check\"><b>Jahr</b></label></td><td><input name=\"year\" size=\"6\" maxlength=\"4\" value=\"\" onchange=\"document.forms[0].jahr_check.checked=true;\" onfocus=\"document.forms[0].jahr_check.checked=true;\" tabindex=\"5\" /></td></tr>";
					echo "<tr bgcolor=\"#DDDDDD\"><td><input type=\"checkbox\" name=\"genre_check\" value=\"1\" id=\"genre_check\" />&nbsp;<label for=\"genre_check\"><b>Genre</b></label></td><td><select name=\"genre\" onchange=\"document.forms[0].genre_check.checked=true;\" onfocus=\"document.forms[0].genre_check.checked=true;\" tabindex=\"6\" style=\"width:250px;\"><option></option>";
					for(reset($GENRE);list($key,$val)=each($GENRE);) echo "<option value=\"".htmlentities($key)."\">".htmlentities($val)."</option>";
					echo "</select></td></tr>";
					echo "<tr bgcolor=\"#DDDDDD\"><td><input type=\"checkbox\" name=\"comment_check\" value=\"1\" id=\"comment_check\" />&nbsp;<label for=\"comment_check\"><b>Kommentar</b></label></td><td><textarea name=\"comment\" cols=\"30\" rows=\"5\" onchange=\"document.forms[0].comment_check.checked=true;\" onfocus=\"document.forms[0].comment_check.checked=true;\" tabindex=\"7\" style=\"width:250px;\">".($mp3info["id3v2"]?$mp3info["comment"]:"")."</textarea></td></tr>";
					echo "</table><br />";
					echo "<br />";
					echo "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\">";
					echo "<tr><td><b>&nbsp;ID3v1&nbsp;</b></td><td><b>&nbsp;D3v2&nbsp;</b></td><td></td></tr>";
					echo "<tr><td align=\"center\"><input type=\"radio\" name=\"id3v1\" value=\"edit\" checked=\"checked\" /></td><td align=\"center\"><input type=\"radio\" name=\"id3v2\" value=\"edit\" checked=\"checked\" /></td><td>Oben gew&auml;hlte Felder aktualisieren</td></tr>";
					echo "<tr><td align=\"center\"><input type=\"radio\" name=\"id3v1\" value=\"leave\" /></td><td align=\"center\"><input type=\"radio\" name=\"id3v2\" value=\"leave\" /></td><td>Unver&auml;ndert lassen</td></tr>";
					echo "<tr><td align=\"center\"><input type=\"radio\" name=\"id3v1\" value=\"delete\" /></td><td align=\"center\"><input type=\"radio\" name=\"id3v2\" value=\"delete\" /></td><td>Tag entfernen</td></tr>";
					echo "</table>";
					echo "<br />";
					echo "<input type=\"submit\" value=\"Dateien modifizieren\" />";
				}
				else
				{
					echo $str_form_addsong;
				}
				echo "</td></tr></table></form><br />";
			}
			else
			{
				echo "In der Playliste sind keine g&uuml;ltigen Eintr&auml;ge. Wahrscheinlich wurden die Songs verschoben oder gel&ouml;scht.<br />";
				echo "<br />";
				echo "<a href=\"$PHP_SELF?action=dir&amp;d=".urlencode(dirname($datei))."\">Zur&uuml;ck</a><br />";
			}
		}
	}
	else
	{
		echo $HEAD;
		echo "<b>Ung&uuml;ltige Auswahl</b><br />";
		echo "Die Datei existiert zwar, wird jedoch nicht unterst&uuml;tzt. Derzeit werden lediglich MP3-Dateien (*.mp3), Playlisten (*.m3u) und Verzeichnisse unterst&uuml;tzt.<br /><br />";
		echo "<a href=\"$PHP_SELF?action=dir\">Zu den Dateien</a> | <a href=\"$PHP_SELF?action=list\">Zur Playliste</a><br />";
	}
	die($FOOT);


}
///////////////////////////////////////////////////////////////////////////////
//   D A T E I E N   Z E I G E N                                             //
///////////////////////////////////////////////////////////////////////////////
elseif($action=="view")
{
	if(is_dir($MP3DIR.$datei))
	{
		header("Location: http://".getenv("HTTP_HOST")."$PHP_SELF?action=dir&d=".urlencode($datei));
		exit;
	}
	if(strtolower(substr($datei,-4))==".mp3")
	{
		header("Location: http://".getenv("HTTP_HOST")."$PHP_SELF?action=add&datei=".urlencode($datei));
		exit;
	}
	echo $HEAD; flush();
	// z.zt. nur m3u und txt
	if(strtolower(substr($datei,-4))==".txt" || strtolower(substr($datei,-4))==".m3u")
	{
		if(is_file($MP3DIR.$datei) && is_readable($MP3DIR.$datei))
		{
			echo "<b>Datei: ".dir_str($datei)."</b>".(is_writeable($MP3DIR.$datei)?"":" (schreibgesch&uuml;tzt)")."<br />";
			echo "<br />"; flush();
			// speichern der datei
			if($view=="save")
			{
				if(is_writeable($MP3DIR.$datei))
				{
					$fp = fopen($MP3DIR.$datei,"w");
					if($fp)
					{
						fputs($fp,stripslashes($inhalt));
						fclose($fp);
						echo "Schreiben der Datei beendet.<br />";
						echo "<br />";
						back_button("action=dir&amp;d=".urlencode(dirname($datei)),array("meta","link"));
					}
					else echo "Fehler beim &Ouml;ffnen der Datei<br />";
				}
				else echo "Die Datei ist schreibgesch&uuml;tzt. Daher k&ouml;nnen die &Auml;nderungen nicht gespeichert werden.<br />";
			}
			else
			{
				// anzeigen der datei
				$fp = fopen($MP3DIR.$datei,"r");
				if($fp)
				{
					// falls schreibbar, dann formular
					if(is_writeable($MP3DIR.$datei))
					{
						echo "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\"><tr><td align=\"center\">";
						echo "<form method=\"post\" action=\"$PHP_SELF\" accept-charset=\"iso-8859-1\"><input type=\"hidden\" name=\"action\" value=\"$action\" /><input type=\"hidden\" name=\"view\" value=\"save\" /><input type=\"hidden\" name=\"datei\" value=\"".htmlentities($datei)."\" />";
						echo "<textarea name=\"inhalt\" cols=\"80\" rows=\"20\">";
						while(!feof($fp)) echo htmlentities(fgets($fp,1024));
						echo "</textarea><br />";
						echo "<input type=\"submit\" value=\"Speichern\" />";
						echo "<input type=\"reset\" value=\"Zur&uuml;cksetzen\" />";
						echo "</form><form method=\"post\" action=\"$PHP_SELF\" accept-charset=\"iso-8859-1\"><input type=\"hidden\" name=\"action\" value=\"file\" /><input type=\"hidden\" name=\"file\" value=\"delete\" /><input type=\"hidden\" name=\"datei\" value=\"".htmlentities($datei)."\" />";
						echo "<input type=\"submit\" value=\"L&ouml;schen\" />";
						echo "</form></td></tr></table>";
					// ansonsten nur inhalt ausgeben
					}
					else
					{
						echo "<hr /><pre>";
						while(!feof($fp)) echo (htmlentities(fgets($fp,1024)));
						echo "</pre><hr />";
					}
					fclose($fp);
				} else echo "Fehler beim &Ouml;ffnen der Datei<br />";
			}
		} else echo "Die Datei existiert nicht.<br />";
	} else echo "Die Datei-Endung wird derzeit nicht unterst&uuml;tzt.<br />";
	die($FOOT);


}
///////////////////////////////////////////////////////////////////////////////
//   D A T E I E N   B E A R B E I T E N                                     //
///////////////////////////////////////////////////////////////////////////////
elseif($action=="file")
{
	// neue text-datei erstellen
	if($file=="newtext")
	{
		if(!is_dir($MP3DIR.$d))
		{
			header("Location: http://".getenv("HTTP_HOST")."$PHP_SELF?action=dir&d=".urlencode(dirname($d))."");
			exit;
		}
		// pruefen des dateinamens und erstellen der datei
		if($newtext=="save")
		{
			$errmsg = array();
			if(strstr($datei,"/")) $errmsg[] = "Bitte gebe einen g&uuml;ltigen Dateinamen ein.";
			if(strtolower(substr($datei,-4))!=".txt") $errmsg[] = "Es k&ouml;nnen nur Text-Dateien mit der Endung .txt erstellt werden.";
			if(strlen($datei)<6) $errmsg[] = "Der Dateiname ist zu kurz.";
			if(!is_writeable($MP3DIR.$d)) $errmsg[] = "Das Verzeichnis ist nicht beschreibbar.";
			if(count($errmsg))
			{
				echo $HEAD; flush();
				echo "<b>Fehler beim Erstellen der Datei $datei</b><br />";
				echo "<br />";
				echo implode("<br />",$errmsg);
			}
			else
			{
				if($d) $d .= "/";
				if(file_exists($MP3DIR.$d.$datei) || $fp = fopen($MP3DIR.$d.$datei,"w"))
				{
					if($fp) fclose($fp);
					// alles klar? dann ab zum bearbeiten der datei
					header("Location: http://".getenv("HTTP_HOST")."$PHP_SELF?action=view&datei=$d$datei"); exit;
				}
				echo $HEAD."Die Datei kann nicht erstellt werden.<br />";
			}
		// formular zur eingabe des dateinamens
		}
		else
		{
			if(!trim($datei)) $datei=$INFOFILE;
			echo $HEAD; flush();
			echo "<b>Erstellen einer neuen Text-Datei im Verzeichnis ".dir_str($d)."</b><br />";
			echo "<br />";
			echo "<form method=\"post\" action=\"$PHP_SELF\" accept-charset=\"iso-8859-1\"><input type=\"hidden\" name=\"action\" value=\"$action\" /><input type=\"hidden\" name=\"file\" value=\"".htmlentities($file)."\" /><input type=\"hidden\" name=\"newtext\" value=\"save\" /><input type=\"hidden\" name=\"d\" value=\"".htmlentities($d)."\" />";
			echo "<input name=\"datei\" value=\"".htmlentities($datei)."\" /> <input type=\"submit\" value=\" OK \" />";
			echo "</form>";
		}
	// dateien loeschen
	}
	elseif($file=="delete")
	{
		$errmsg = array();
		// alles checken..
		if(!file_exists($MP3DIR.$datei)) $errmsg[] = "Die Datei existiert nicht.";
		if(strtolower(substr($datei,-4))!=".txt" && strtolower(substr($datei,-4))!=".m3u") $errmsg[] = "Die Datei ist keine Text-Datei oder Playliste";
		if(!is_writeable($MP3DIR.$datei)) $errmsg[] = "Falsche Rechte der Datei: Sie kann nicht gel&ouml;scht werden.";
		if(count($errmsg))
		{
			echo $HEAD; flush();
			echo "<b>Fehler beim L&ouml;schen der Datei $datei</b><br />";
			echo "<br />";
			echo implode("<br />",$errmsg);
		}
		else
		{
			// ...und weg isse, und ab zum verzeichnis
			if(unlink($MP3DIR.$datei))
			{
				header("Location: http://".getenv("HTTP_HOST")."$PHP_SELF?action=dir&d=".urlencode(dirname($datei))."");
				exit;
			}
			else
			{
				echo $HEAD; flush();
				echo "Die Datei konnte nicht gel&ouml;scht werden.";
			}
		}
	// ID3-Tag bearbeiten
	}
	elseif($file=="id3")
	{
		echo $HEAD; flush();
		if(strtolower(substr($datei,-4))==".mp3")
		{
			echo "<b>".dir_str($datei)."</b><br />";
			echo "<br />";
			if($id3=="save")
			{
				if($id3v1) id3v1save($datei,$song,$artist,$album,$year,$comment,$track,$genre);
				else       id3v1remove($datei);
				if($id3v2) id3v2save($datei,$id3v2_song,$id3v2_artist,$id3v2_album,$id3v2_year,$id3v2_comment,$id3v2_track,$id3v2_genre);
				else       id3v2remove($datei);
				echo "<br />";
				back_button("action=file&amp;file=id3&amp;datei=".urlencode($datei),array("link"));
			}
			else
			{
				$mp3info = mp3_getinfo($datei,1,1);
				echo "<form method=\"post\" action=\"$PHP_SELF\" accept-charset=\"iso-8859-1\" name=\"id3\"><input type=\"hidden\" name=\"action\" value=\"file\" /><input type=\"hidden\" name=\"file\" value=\"id3\" /><input type=\"hidden\" name=\"id3\" value=\"save\" /><input type=\"hidden\" name=\"datei\" value=\"".htmlentities($datei)."\" />";
				echo "<table border=\"0\" width=\"650\">";
				echo "<tr><td style=\"vertical-align:top;\">";
				// ID3v1
				echo "<table border=\"0\">";
				echo "<tr bgcolor=\"#D4DDEE\"><td colspan=\"2\"><b><input type=\"checkbox\" name=\"id3v1\" id=\"id3v1\" value=\"1\"".($mp3info["id3v1"]?" checked=\"checked\"":"")." onclick=\"check_id3()\" onchange=\"check_id3()\" /> <label for=\"id3v1\">ID3v1 Details</label></b></td></tr>";
				echo "<tr bgcolor=\"#DDDDDD\"><td><b>Song</b></td><td><input name=\"song\" id=\"song\" size=\"25\" maxlength=\"30\" value=\"".htmlentities($mp3info["id3song"])."\" onchange=\"id3v1_add()\" onfocus=\"id3v1_add()\" /></td></tr>";
				echo "<tr bgcolor=\"#DDDDDD\"><td><b>Artist</b></td><td><input name=\"artist\" id=\"artist\" size=\"25\" maxlength=\"30\" value=\"".htmlentities($mp3info["id3artist"])."\" onchange=\"id3v1_add()\" onfocus=\"id3v1_add()\" /></td></tr>";
				echo "<tr bgcolor=\"#DDDDDD\"><td><b>Album</b></td><td><input name=\"album\" id=\"album\" size=\"25\" maxlength=\"30\" value=\"".htmlentities($mp3info["id3album"])."\" onchange=\"id3v1_add()\" onfocus=\"id3v1_add()\" /></td></tr>";
				echo "<tr bgcolor=\"#DDDDDD\"><td><b>Track</b></td><td><input name=\"track\" id=\"track\" size=\"6\" maxlength=\"2\" value=\"".htmlentities($mp3info["id3track"])."\" onchange=\"id3v1_add()\" onfocus=\"id3v1_add()\" /></td></tr>";
				echo "<tr bgcolor=\"#DDDDDD\"><td><b>Jahr</b></td><td><input name=\"year\" id=\"year\" size=\"6\" maxlength=\"4\" value=\"".htmlentities($mp3info["id3year"])."\" onchange=\"id3v1_add()\" onfocus=\"id3v1_add()\" /></td></tr>";
				echo "<tr bgcolor=\"#DDDDDD\"><td><b>Genre</b></td><td><select name=\"genre\" id=\"genre\" onchange=\"id3v1_add()\" onfocus=\"id3v1_add()\"><option></option>";
				for(reset($GENRE);list($key,$val)=each($GENRE);) echo "<option value=\"$key\"".($key==$mp3info["id3genre"]?" selected=\"selected\"":"").">".htmlentities($val)."</option>";
				echo "</select></td></tr>";
				echo "<tr bgcolor=\"#DDDDDD\"><td><b>Kommentar</b></td><td><input name=\"comment\" id=\"comment\" size=\"25\" maxlength=\"28\" value=\"".htmlentities($mp3info["id3comment"])."\" onchange=\"id3v1_add()\" onfocus=\"id3v1_add()\" /></td></tr>";
				echo "<tr><td><input type=\"submit\" value=\"Speichern\" /></td><td><input type=\"reset\" value=\"Reset\" /></td></tr>";
				echo "</table>";
				echo "</td><td width=\"25\"></td><td style=\"vertical-align:top;\">";
				// ID3v2
?>
<script type="text/javascript">
<!--
function id3v1_add()
{
	document.getElementById("id3v1").checked=true;
}

function id3v2_add()
{
	document.getElementById("id3v2").checked=true;
}

function check_id3()
{
	if(document.getElementById("id3v1").checked == false)
	{
		document.getElementById("song").value = '';
		document.getElementById("artist").value = '';
		document.getElementById("album").value = '';
		document.getElementById("track").value = '';
		document.getElementById("year").value = '';
		document.getElementById("comment").value = '';
		document.getElementById("genre").options[0].selected=true;
	}
	if(document.getElementById("id3v2").checked == false)
	{
		document.getElementById("id3v2_song").value = '';
		document.getElementById("id3v2_artist").value = '';
		document.getElementById("id3v2_album").value = '';
		document.getElementById("id3v2_track").value = '';
		document.getElementById("id3v2_year").value = '';
		document.getElementById("id3v2_comment").value = '';
		document.getElementById("id3v2_genre").options[0].selected=true;
	}
}

function id3v1t2()
{
	if(document.getElementById("id3v1").checked == true)
	{
		document.getElementById("id3v2").checked = true;
		document.getElementById("id3v2_song").value = document.getElementById("song").value;
		document.getElementById("id3v2_artist").value = document.getElementById("artist").value;
		document.getElementById("id3v2_album").value = document.getElementById("album").value;
		document.getElementById("id3v2_track").value = document.getElementById("track").value;
		document.getElementById("id3v2_year").value = document.getElementById("year").value;
		document.getElementById("id3v2_comment").value = document.getElementById("comment").value;
		document.getElementById("id3v2_genre").options[document.getElementById("genre").selectedIndex].selected=true;
	}
}

function id3v2t1()
{
	if(document.getElementById("id3v2").checked == true)
	{
		document.getElementById("id3v1").checked = true;
		document.getElementById("song").value = document.getElementById("id3v2_song").value;
		document.getElementById("artist").value = document.getElementById("id3v2_artist").value;
		document.getElementById("album").value = document.getElementById("id3v2_album").value;
		document.getElementById("track").value = document.getElementById("id3v2_track").value;
		document.getElementById("year").value = document.getElementById("id3v2_year").value;
		document.getElementById("comment").value = document.getElementById("id3v2_comment").value;
		document.getElementById("genre").options[document.getElementById("id3v2_genre").selectedIndex].selected=true;
	}
}
//-->
</script>
<?php
				echo "<table border=\"0\">";
				echo "<tr bgcolor=\"#D4DDEE\"><td colspan=\"2\"><b><input type=\"checkbox\" name=\"id3v2\" id=\"id3v2\" value=\"1\"".($mp3info["id3v2"]?" checked=\"checked\"":"")." onclick=\"check_id3()\" onchange=\"check_id3()\" /> <label for=\"id3v2\">ID3v2 Details</label></b> (<a href=\"javascript:id3v1t2();\">von ID3v1</a>, <a href=\"javascript:id3v2t1();\">nach ID3v1</a>)</td></tr>";
				echo "<tr bgcolor=\"#DDDDDD\"><td><b>Song</b></td><td><input name=\"id3v2_song\" id=\"id3v2_song\" size=\"25\" value=\"".htmlentities($mp3info["id3v2"]?$mp3info["song"]:"")."\" onchange=\"id3v2_add()\" onfocus=\"id3v2_add()\" /></td></tr>";
				echo "<tr bgcolor=\"#DDDDDD\"><td><b>Artist</b></td><td><input name=\"id3v2_artist\" id=\"id3v2_artist\" size=\"25\" value=\"".htmlentities($mp3info["id3v2"]?$mp3info["artist"]:"")."\" onchange=\"id3v2_add()\" onfocus=\"id3v2_add()\" /></td></tr>";
				echo "<tr bgcolor=\"#DDDDDD\"><td><b>Album</b></td><td><input name=\"id3v2_album\" id=\"id3v2_album\" size=\"25\" value=\"".htmlentities($mp3info["id3v2"]?$mp3info["album"]:"")."\" onchange=\"id3v2_add()\" onfocus=\"id3v2_add()\" /></td></tr>";
				echo "<tr bgcolor=\"#DDDDDD\"><td><b>Track</b></td><td><input name=\"id3v2_track\" id=\"id3v2_track\" size=\"6\" maxlength=\"2\" value=\"".htmlentities($mp3info["id3v2"]?$mp3info["track"]:"")."\" onchange=\"id3v2_add()\" onfocus=\"id3v2_add()\" /></td></tr>";
				echo "<tr bgcolor=\"#DDDDDD\"><td><b>Jahr</b></td><td><input name=\"id3v2_year\" id=\"id3v2_year\" size=\"6\" maxlength=\"4\" value=\"".htmlentities($mp3info["id3v2"]?$mp3info["year"]:"")."\" onchange=\"id3v2_add()\" onfocus=\"id3v2_add()\" /></td></tr>";
				echo "<tr bgcolor=\"#DDDDDD\"><td><b>Genre</b></td><td><select name=\"id3v2_genre\" id=\"id3v2_genre\" onchange=\"id3v2_add()\" onfocus=\"id3v2_add()\"><option></option>";
				for(reset($GENRE);list($key,$val)=each($GENRE);) echo "<option value=\"$key\"".($key==$mp3info["genre"] && $mp3info["id3v2"]?" selected=\"selected\"":"").">".htmlentities($val)."</option>";
				echo "</select></td></tr>";
				echo "<tr bgcolor=\"#DDDDDD\"><td><b>Kommentar</b></td><td><textarea name=\"id3v2_comment\" id=\"id3v2_comment\" cols=\"30\" rows=\"5\" onchange=\"id3v2_add()\" onfocus=\"id3v2_add()\">".($mp3info["id3v2"]?$mp3info["comment"]:"")."</textarea></td></tr>";
				echo "</table>";
				echo "</td></tr><tr><td colspan=\"3\">";
				echo "<br />";
				echo "<b>Informationen zum ID3-Tag</b><br />";
				echo "<br />";
				echo "Der ID3-Tag ist eine sehr nette Erfindung um in einer MP3-Datei neben den Musik-Daten auch Informationen &uuml;ber die enthaltene Musik in Textform zu speichern. Zun&auml;chst waren diese Informationen auf 128 Byte am Ende der Datei begrenzt (ID3v1). F&uuml;r Song-Namen, Artist, Album und Kommentar standen jeweils nur maximal 30 Zeichen zur Verf&uuml;gung.<br />";
				echo "Da das jedoch recht unpraktisch ist, wurde ein neuer Standard entworfen: ID3v2. Hierbei werden die Daten am Anfang der Datei gespeichert und die gesamten Informationen sind auf 256MB beschr&auml;nkt (max. 16MB pro Information). Auch die Anzahl der Informationen wurde drastisch erh&ouml;ht und wird auch immer weiter entwickelt, so k&ouml;nnen sogar Bilder gespeichert werden.<br />";
				echo "Der Nachteil von ID3v2 ist jedoch, das &auml;ltere MP3-Player diese Informationen nicht anzeigen k&ouml;nnen.<br />";
				echo "Die Funktion des MusicServers bei den ID3v2-Tags ist zun&auml;chst auf die von ID3v1 beschr&auml;nkt, wird aber noch weiterentwickelt.<br />";
				echo "</td></tr></table>";
				echo "</form>";
			}
		} else echo "Das ist keine MP3-Datei!";
	}
	else
	{
		header("Location: http://".getenv("HTTP_HOST")."$PHP_SELF");
		exit;
	}
	die($FOOT);


}
///////////////////////////////////////////////////////////////////////////////
//   V E R Z E I C H N I S   B R O W S E R                                   //
///////////////////////////////////////////////////////////////////////////////
else
{
	settype($d, "string");
	$d = stripslashes($d);
	// pruefe ob verzeichnis gueltig ist
	if(!is_dir($MP3DIR.$d))
	{
		header("Location: http://".getenv("HTTP_HOST")."$PHP_SELF?action=dir&d=".urlencode((dirname($d)==basename($d)?"/":dirname($d)))."");
		exit;
	}
	// setze verzeichnis zusammen
	$D = $MP3DIR . $d;

	echo $HEAD; flush();
	$dir_str = dir_str($d);
	echo "<b>Verzeichnis $dir_str</b><br /><hr />";
	// anzeigen der info-datei
	if(file_exists($D."/".$INFOFILE) && is_readable($D."/".$INFOFILE))
	{
		$fp = fopen($D."/".$INFOFILE,"r");
		$DIRINFO = "";
		while(!feof($fp))
		{
			$DIRINFO .= fgets($fp,1024);
		}
		fclose($fp);
		echo nl2br(htmlentities(trim($DIRINFO)));
		echo "<hr />";
	}
	echo "<table border=\"0\" cellspacing=\"0\">";
	if($d) echo "<tr><td valign=\"middle\"><img src=\"type_dir.gif\" width=\"16\" height=\"16\" alt=\"Verzeichnis\" /></td><td valign=\"middle\">&nbsp;<a href=\"$PHP_SELF?action=dir&amp;d=".urlencode((dirname($d)==basename($d)?"":dirname($d)))."\">../</a></td></tr>";
	// variablen deklarieren
	$VER_DIR = array();
	$VER_MP3 = array();
	$VER_M3U = array();
	$VER_TXT = array();
	$VER_OTH = array();
	// lese verzeichnis aus und schreibe daten in arrays
	$verz = dir($D);
	while($row = $verz->read())
	{
		if(substr($row,0,1)!=".")
		{
			if(is_dir($D."/".$row)) $VER_DIR[] = $row;
			elseif(strtolower(substr($row,-4))==".mp3") $VER_MP3[] = $row;
			elseif(strtolower(substr($row,-4))==".m3u") $VER_M3U[] = $row;
			elseif(strtolower(substr($row,-4))==".txt") $VER_TXT[] = $row;
			else $VER_OTH[] = $row;
		}
	}
	$verz->close();
	// arrays sortieren...
	sort($VER_DIR);
	sort($VER_MP3);
	sort($VER_M3U);
	sort($VER_TXT);
	sort($VER_OTH);
	// ...und ausgeben
	while(list(,$row)=each($VER_DIR)) echo "<tr><td valign=\"middle\"><img src=\"type_dir.gif\" width=\"16\" height=\"16\" alt=\"Verzeichnis\" /></td><td valign=\"middle\">&nbsp;<a href=\"$PHP_SELF?action=dir&amp;d=".urlencode($d.(!$d?"":"/").$row)."\">".htmlentities($row)."/</a></td></tr>";
	while(list(,$row)=each($VER_MP3)) echo "<tr><td valign=\"middle\"><img src=\"type_mp3.gif\" width=\"16\" height=\"16\" alt=\"MP3\" /></td><td valign=\"middle\">&nbsp;<a href=\"$PHP_SELF?action=add&amp;datei=".urlencode($d.(!$d?"":"/").$row)."\">".htmlentities($row)."</a></td></tr>";
	while(list(,$row)=each($VER_M3U)) echo "<tr><td valign=\"middle\"><img src=\"type_playlist.gif\" width=\"16\" height=\"16\" alt=\"Playlist\" /></td><td valign=\"middle\">&nbsp;<a href=\"$PHP_SELF?action=add&amp;datei=".urlencode($d.(!$d?"":"/").$row)."\">".htmlentities($row)."</a></td></tr>";
	while(list(,$row)=each($VER_TXT)) echo "<tr><td valign=\"middle\"><img src=\"type_text.gif\" width=\"16\" height=\"16\" alt=\"Plain-Text\" /></td><td valign=\"middle\">&nbsp;<a href=\"$PHP_SELF?action=view&amp;datei=".urlencode($d.(!$d?"":"/").$row)."\">".htmlentities($row)."</a></td></tr>";
	while(list(,$row)=each($VER_OTH)) echo "<tr><td valign=\"middle\"><img src=\"type_none.gif\" width=\"16\" height=\"16\" alt=\"none\" /></td><td valign=\"middle\">&nbsp;$row</td></tr>";
	echo "</table>";
	echo "<hr />";
	echo "<table border=\"0\" cellspacing=\"0\">";
	if(count($VER_MP3))
	{
		echo "<tr><td valign=\"middle\"><img src=\"type_mp3.gif\" width=\"16\" height=\"16\" alt=\"MP3s hinzuf&uuml;gen\" /></td><td valign=\"middle\">&nbsp;<a href=\"$PHP_SELF?action=add&amp;datei=".urlencode($d)."\">Dieses komplette Verzeichnis hinzuf&uuml;gen</a></td></tr>";
		echo "<tr><td valign=\"middle\"><img src=\"type_mp3b.gif\" width=\"16\" height=\"16\" alt=\"Multi-ID3-Tag-Edit\" /></td><td valign=\"middle\">&nbsp;<a href=\"$PHP_SELF?action=add&amp;add=id3&amp;datei=".urlencode($d)."\">ID3-Tags der MP3s in diesem Verzeichnis bearbeiten</a></td></tr>";
	}
	echo "<tr><td valign=\"middle\"><img src=\"type_search.gif\" width=\"16\" height=\"16\" alt=\"Suchen\" /></td><td valign=\"middle\">&nbsp;<a href=\"$PHP_SELF?action=search\">Nach Songs suchen</a></td></tr>";
	if(is_writeable($D)) echo "<tr><td valign=\"middle\"><img src=\"type_text.gif\" width=\"16\" height=\"16\" alt=\"Neue Text-Datei erstellen\" /></td><td valign=\"middle\">&nbsp;<a href=\"$PHP_SELF?action=file&amp;d=".urlencode($d)."&amp;file=newtext\">Neue Text-Datei erstellen</a></td></tr>";
	echo "</table>";
	die($FOOT);
}

?>