/*
	Juchu! Mein erstes C Programm. Eigentlich nur geklaut, aber das merkt ja keiner...
*/

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <fcntl.h>

#include <sys/ioctl.h>
#include <sys/types.h>
#include <unistd.h>
#include <linux/soundcard.h>


#define MAXVOL 25700	// maximale lautstaerke
#define MINVOL 0		// minimale lautstaerke
#define SCHRITT 514		// schritt fuer lautstaerke-regelung
#define MIXER "/dev/mixer"	// mixerdevice

int mixerfd;



// Aktuelle Einstellung lesen
int readvalue() {
	int flags;

	ioctl(mixerfd, MIXER_READ(0), &flags);

	return(flags);
}


// Lautstaerke setzen
int writevalue(int flags) {
	ioctl(mixerfd, MIXER_WRITE(0), &flags);

	return(0);
}

int setzen(int newstatus) {
	if(newstatus > MAXVOL)
	{
		newstatus = MAXVOL;
	}
	if(newstatus < MINVOL)
	{
		newstatus = MINVOL;
	}
	writevalue(newstatus);
	return(0);
}

int main(int argc, char *argv[]) {

	int newstatus;

	// mixerdevice oeffnen (/dev/mixer z.b.)

	if((mixerfd = open(MIXER, O_RDWR | O_NDELAY)) < 0)
	{
		printf("mixer konnte nicht geoeffnet werden\n");
		exit(1);
	}

	if(argc==2)
	{
		//newstatus = (int)argv[1];
		setzen(atoi(argv[1]));
	}

	printf("%i\n",readvalue());

	close(mixerfd);

	return(0);
}
